@x [1] m.2 l.250 - e-TeX basic
@d eTeX_version_string=='2.1' {current \eTeX\ version}
@d eTeX_version=2 { \.{\\eTeXversion} }
@d eTeX_revision==".1" { \.{\\eTeXrevision} }
@#
@d eTeX_banner=='This is e-TeX, Version ',eTeX_version_string
  {printed when \eTeX\ starts}
@#
@d TEX==ETEX {change program name into |ETEX|}
@y
@d eTeX_version_string=='2.1' {current \eTeX\ version}
@d eTeX_version=2 { \.{\\eTeXversion} }
@d eTeX_revision==".1" { \.{\\eTeXrevision} }
@d eeTeX_version_string=='-e2' {current \eTeX\ version}
@d eeTeX_version=2 { \.{\\eeTeXversion} }
@#
@d eTeX_banner=='This is eeTeX, Version ',eTeX_version_string,eeTeX_version_string
  {printed when e\eTeX\ starts}
@#
@d TEX==EETEX {change program name into |EETEX|}
@z

@x
@d hi_mem_stat_min==mem_top-14 {smallest statically allocated word in
  the one-word |mem|}
@d hi_mem_stat_usage=15 {the number of one-word nodes always present}
@y
@d hi_mem_stat_min==mem_top-17 {smallest statically allocated word in
  the one-word |mem|} {this change needed for \.{\\listsep}}
@d hi_mem_stat_usage=18 {the number of one-word nodes always present}
@z

@x [15] m.210 l.4311
@d call=max_command+11 {non-long, non-outer control sequence}
@d long_call=max_command+12 {long, non-outer control sequence}
@d outer_call=max_command+13 {non-long, outer control sequence}
@d long_outer_call=max_command+14 {long, outer control sequence}
@d end_template=max_command+15 {end of an alignment template}
@d dont_expand=max_command+16 {the following token was marked by \.{\\noexpand}}
@d glue_ref=max_command+17 {the equivalent points to a glue specification}
@d shape_ref=max_command+18 {the equivalent points to a parshape specification}
@d box_ref=max_command+19 {the equivalent points to a box node, or is |null|}
@d data=max_command+20 {the equivalent is simply a halfword number}
@y
@d list_call=max_command+11 {the equivalent is a list}
@d dict_call=max_command+12 {the equivalent is a dictionary}
@d call=max_command+13 {non-long, non-outer control sequence}
@d long_call=max_command+14 {long, non-outer control sequence}
@d outer_call=max_command+15 {non-long, outer control sequence}
@d long_outer_call=max_command+16 {long, outer control sequence}
@d end_template=max_command+17 {end of an alignment template}
@d dont_expand=max_command+18 {the following token was marked by \.{\\noexpand}}
@d glue_ref=max_command+19 {the equivalent points to a glue specification}
@d shape_ref=max_command+20 {the equivalent points to a parshape specification}
@d box_ref=max_command+21 {the equivalent points to a box node, or is |null|}
@d data=max_command+22 {the equivalent is simply a halfword number}
@z

@x l.4655
@d frozen_null_font=frozen_control_sequence+10
  {permanent `\.{\\nullfont}'}
@y
@d frozen_null_font=frozen_control_sequence+11
  {permanent `\.{\\nullfont}'}
@z

@x [17] m.223 l.4673
@<Show equivalent |n|, in region 1 or 2@>=
begin sprint_cs(n); print_char("="); print_cmd_chr(eq_type(n),equiv(n));
if eq_type(n)>=call then
  begin print_char(":"); show_token_list(link(equiv(n)),null,32);
  end;
end
@y
@<Show equivalent |n|, in region 1 or 2@>=
begin sprint_cs(n); print_char("="); print_cmd_chr(eq_type(n),equiv(n));
if eq_type(n)>=list_call then
  if eq_type(n)=list_call then begin print_char(":"); print_char("(");
		print_int(info(equiv(n))); print_char(")"); print_char(" ");
		save_cs:=cur_cs; cur_cs:=n; show_the_list; cur_cs:=save_cs; end
  else begin
	print_char(":"); show_token_list(link(equiv(n)),null,32);
    end;
end
@z

@x [17] m.230 l.4859
@d err_help_loc=token_base+12 {points to token list for \.{\\errhelp}}
@d toks_base=token_base+13 {table of 256 token list registers}
@d box_base=toks_base+256 {table of 256 box registers}
@d cur_font_loc=box_base+256 {internal font number outside math mode}
@d math_font_base=cur_font_loc+1 {table of 48 math font numbers}
@d cat_code_base=math_font_base+48
  {table of 256 command codes (the ``catcodes'')}
@d lc_code_base=cat_code_base+256 {table of 256 lowercase mappings}
@d uc_code_base=lc_code_base+256 {table of 256 uppercase mappings}
@d sf_code_base=uc_code_base+256 {table of 256 spacefactor mappings}
@d ef_code_base=sf_code_base+256 {table of 256 font-expand factor mappings}
@d lp_code_base=ef_code_base+256 {table of 256 left-protruding factor mappings}
@d rp_code_base=lp_code_base+256 {table of 256 right-protruding factor mappings}
@d math_code_base=rp_code_base+256 {table of 256 math mode mappings}
@d int_base=math_code_base+256 {beginning of region 5}
@#
@d par_shape_ptr==equiv(par_shape_loc)
@d output_routine==equiv(output_routine_loc)
@d every_par==equiv(every_par_loc)
@d every_math==equiv(every_math_loc)
@d every_display==equiv(every_display_loc)
@d every_hbox==equiv(every_hbox_loc)
@d every_vbox==equiv(every_vbox_loc)
@d every_job==equiv(every_job_loc)
@d every_cr==equiv(every_cr_loc)
@d pdf_pages_attr==equiv(pdf_pages_attr_loc)
@d pdf_page_attr==equiv(pdf_page_attr_loc)
@d pdf_page_resources==equiv(pdf_page_resources_loc)
@d err_help==equiv(err_help_loc)
@d toks(#)==equiv(toks_base+#)
@d box(#)==equiv(box_base+#)
@d cur_font==equiv(cur_font_loc)
@d fam_fnt(#)==equiv(math_font_base+#)
@d cat_code(#)==equiv(cat_code_base+#)
@d lc_code(#)==equiv(lc_code_base+#)
@d uc_code(#)==equiv(uc_code_base+#)
@d sf_code(#)==equiv(sf_code_base+#)
@d ef_code(#)==equiv(ef_code_base+#)
@d lp_code(#)==equiv(lp_code_base+#)
@d rp_code(#)==equiv(rp_code_base+#)
@d math_code(#)==equiv(math_code_base+#)
  {Note: |math_code(c)| is the true math code plus |min_halfword|}
@y
@d list_sep_loc=token_base+12 {points to token list for \.{\\listsep}}
@d err_help_loc=token_base+13 {points to token list for \.{\\errhelp}}
@d toks_base=token_base+14 {table of 256 token list registers}
@d box_base=toks_base+256 {table of 256 box registers}
@d cur_font_loc=box_base+256 {internal font number outside math mode}
@d math_font_base=cur_font_loc+1 {table of 48 math font numbers}
@d cat_code_base=math_font_base+48
  {table of 256 command codes (the ``catcodes'')}
@d lc_code_base=cat_code_base+256 {table of 256 lowercase mappings}
@d uc_code_base=lc_code_base+256 {table of 256 uppercase mappings}
@d sf_code_base=uc_code_base+256 {table of 256 spacefactor mappings}
@d ef_code_base=sf_code_base+256 {table of 256 font-expand factor mappings}
@d lp_code_base=ef_code_base+256 {table of 256 left-protruding factor mappings}
@d rp_code_base=lp_code_base+256 {table of 256 right-protruding factor mappings}
@d math_code_base=rp_code_base+256 {table of 256 math mode mappings}
@d int_base=math_code_base+256 {beginning of region 5}
@#
@d par_shape_ptr==equiv(par_shape_loc)
@d output_routine==equiv(output_routine_loc)
@d every_par==equiv(every_par_loc)
@d every_math==equiv(every_math_loc)
@d every_display==equiv(every_display_loc)
@d every_hbox==equiv(every_hbox_loc)
@d every_vbox==equiv(every_vbox_loc)
@d every_job==equiv(every_job_loc)
@d every_cr==equiv(every_cr_loc)
@d pdf_pages_attr==equiv(pdf_pages_attr_loc)
@d pdf_page_attr==equiv(pdf_page_attr_loc)
@d pdf_page_resources==equiv(pdf_page_resources_loc)
@d err_help==equiv(err_help_loc)
@d list_sep==equiv(list_sep_loc)
@d toks(#)==equiv(toks_base+#)
@d box(#)==equiv(box_base+#)
@d cur_font==equiv(cur_font_loc)
@d fam_fnt(#)==equiv(math_font_base+#)
@d cat_code(#)==equiv(cat_code_base+#)
@d lc_code(#)==equiv(lc_code_base+#)
@d uc_code(#)==equiv(uc_code_base+#)
@d sf_code(#)==equiv(sf_code_base+#)
@d ef_code(#)==equiv(ef_code_base+#)
@d lp_code(#)==equiv(lp_code_base+#)
@d rp_code(#)==equiv(rp_code_base+#)
@d math_code(#)==equiv(math_code_base+#)
  {Note: |math_code(c)| is the true math code plus |min_halfword|}
@z

@x [17] m.230 l.4910
primitive("errhelp",assign_toks,err_help_loc);
@!@:err_help_}{\.{\\errhelp} primitive@>
@y
primitive("listsep",assign_toks,list_sep_loc);
@!@:list_sep_}{\.{\\listsep} primitive@>
primitive("errhelp",assign_toks,err_help_loc);
@!@:err_help_}{\.{\\errhelp} primitive@>
@z

@x [17] m.231 l.4926
  every_cr_loc: print_esc("everycr");
  @/@<Cases of |assign_toks| for |print_cmd_chr|@>@/
@y
  every_cr_loc: print_esc("everycr");
  list_sep_loc: print_esc("listsep");
  @/@<Cases of |assign_toks| for |print_cmd_chr|@>@/
@z

@x [17] m.236 l.5101
@d int_pars=55 {total number of integer parameters}
@d tracing_assigns_code=int_pars {show assignments}
@d tracing_groups_code=int_pars+1 {show save/restore groups}
@d tracing_ifs_code=int_pars+2 {show conditionals}
@d tracing_scan_tokens_code=int_pars+3 {show pseudo file open and close}
@d tracing_nesting_code=int_pars+4
  {show incomplete groups and ifs within files}
@d pre_display_direction_code=int_pars+5 {text direction preceding a display}
@d last_line_fit_code=int_pars+6 {adjustment for last line of paragraph}
@d saving_vdiscards_code=int_pars+7 {save items discarded from vlists}
@d saving_hyph_codes_code=int_pars+8 {save hyphenation codes for languages}
@d eTeX_state_code=int_pars+9 {\eTeX\ state variables}
@y
@d sgml_mode_code=65
@d int_pars=55 {total number of integer parameters}
@d tracing_assigns_code=int_pars {show assignments}
@d tracing_groups_code=int_pars+1 {show save/restore groups}
@d tracing_ifs_code=int_pars+2 {show conditionals}
@d tracing_scan_tokens_code=int_pars+3 {show pseudo file open and close}
@d tracing_nesting_code=int_pars+4
  {show incomplete groups and ifs within files}
@d tracing_lists_code=int_pars+5 {show list operations}
@d tracing_lists==int_par(tracing_lists_code)
@d pre_display_direction_code=int_pars+6 {text direction preceding a display}
@d last_line_fit_code=int_pars+7 {adjustment for last line of paragraph}
@d saving_vdiscards_code=int_pars+8 {save items discarded from vlists}
@d saving_hyph_codes_code=int_pars+9 {save hyphenation codes for languages}
@d eTeX_state_code=int_pars+10 {\eTeX\ state variables}
@z

@x [17] m.236 l.5175
@d error_context_lines==int_par(error_context_lines_code)
@y
@d error_context_lines==int_par(error_context_lines_code)
@d sgml_mode==int_par(sgml_mode_code)
@z

@x [17] m.237 l.5248
error_context_lines_code:print_esc("errorcontextlines");
@y
error_context_lines_code:print_esc("errorcontextlines");
sgml_mode_code:print_esc("sgmlmode");
@z

@x l.5583
@ Here is a procedure that displays the contents of |eqtb[n]|
symbolically.

@p@t\4@>@<Declare the procedure called |print_cmd_chr|@>@;@/
@!stat procedure show_eqtb(@!n:pointer);
begin if n<active_base then print_char("?") {this can't happen}
else if n<glue_base then @<Show equivalent |n|, in region 1 or 2@>
else if n<local_base then @<Show equivalent |n|, in region 3@>
else if n<int_base then @<Show equivalent |n|, in region 4@>
else if n<dimen_base then @<Show equivalent |n|, in region 5@>
else if n<=eqtb_size then @<Show equivalent |n|, in region 6@>
else print_char("?"); {this can't happen either}
end;
tats
@y
@ Here is a procedure that displays the contents of |eqtb[n]|
symbolically.  TH: Needed a variable top save |cur_cs| in for 
showing a list (Region 2).

@p@t\4@>@<Declare the procedure called |print_cmd_chr|@>@;@/
@!stat procedure show_eqtb(@!n:pointer);
var @!save_cs:halfword;
begin if n<active_base then print_char("?") {this can't happen}
else if n<glue_base then @<Show equivalent |n|, in region 1 or 2@>
else if n<local_base then @<Show equivalent |n|, in region 3@>
else if n<int_base then @<Show equivalent |n|, in region 4@>
else if n<dimen_base then @<Show equivalent |n|, in region 5@>
else if n<=eqtb_size then @<Show equivalent |n|, in region 6@>
else print_char("?"); {this can't happen either}
end;
tats
@z

@x l.6142
@ To save a value of |eqtb[p]| that was established at level |l|, we
can use the following subroutine.

@p procedure eq_save(@!p:pointer;@!l:quarterword); {saves |eqtb[p]|}
begin check_full_save_stack;
if l=level_zero then save_type(save_ptr):=restore_zero
else  begin save_stack[save_ptr]:=eqtb[p]; incr(save_ptr);
  save_type(save_ptr):=restore_old_value;
  end;
save_level(save_ptr):=l; save_index(save_ptr):=p; incr(save_ptr);
end;
@y
@ To save a value of |eqtb[s]| that was established at level |l|, we
can use the following subroutine.

@p procedure eq_save(@!s:pointer;@!l:quarterword); {saves |eqtb[s]|}
var a,b,p,q:pointer; {pointers for list copying}
begin check_full_save_stack;
if l=level_zero then save_type(save_ptr):=restore_zero
else  begin 
  save_stack[save_ptr]:=eqtb[s]; 
  incr(save_ptr);
  save_type(save_ptr):=restore_old_value;
  end;
save_level(save_ptr):=l; save_index(save_ptr):=s; incr(save_ptr);
end;
@z



@x [20] m.296 l.6523
@ The |print_meaning| subroutine displays |cur_cmd| and |cur_chr| in
symbolic form, including the expansion of a macro or mark.

@p procedure print_meaning;
begin print_cmd_chr(cur_cmd,cur_chr);
if cur_cmd>=call then
  begin print_char(":"); print_ln; token_show(cur_chr);
  end
else if (cur_cmd=top_bot_mark)and(cur_chr<marks_code) then
  begin print_char(":"); print_ln;
  token_show(cur_mark[cur_chr]);
  end;
end;
@y
@ The |print_meaning| subroutine displays |cur_cmd| and |cur_chr| in
symbolic form, including the expansion of a macro, list or mark.

@p procedure print_meaning;
begin print_cmd_chr(cur_cmd,cur_chr);
if cur_cmd>=list_call then
  begin 
    print_char(":"); print_ln; 
      if cur_cmd=list_call then begin expand_list; end
	  else token_show(cur_chr);
  end
else if (cur_cmd=top_bot_mark)and(cur_chr<marks_code) then
  begin print_char(":"); print_ln;
  token_show(cur_mark[cur_chr]);
  end;
end;
@z

@x l.6927
@d token_list=0 {|state| code when scanning a token list}
@d token_type==index {type of current token list}
@d param_start==limit {base of macro parameters in |param_stack|}
@d parameter=0 {|token_type| code for parameter}
@d u_template=1 {|token_type| code for \<u_j> template}
@d v_template=2 {|token_type| code for \<v_j> template}
@d backed_up=3 {|token_type| code for text to be reread}
@d inserted=4 {|token_type| code for inserted texts}
@d macro=5 {|token_type| code for defined control sequences}
@d output_text=6 {|token_type| code for output routines}
@d every_par_text=7 {|token_type| code for \.{\\everypar}}
@d every_math_text=8 {|token_type| code for \.{\\everymath}}
@d every_display_text=9 {|token_type| code for \.{\\everydisplay}}
@d every_hbox_text=10 {|token_type| code for \.{\\everyhbox}}
@d every_vbox_text=11 {|token_type| code for \.{\\everyvbox}}
@d every_job_text=12 {|token_type| code for \.{\\everyjob}}
@d every_cr_text=13 {|token_type| code for \.{\\everycr}}
@d every_eof_text=14 {|token_type| code for \.{\\everyeof}}
@d mark_text=15 {|token_type| code for \.{\\topmark}, etc.}
@d write_text=16 {|token_type| code for \.{\\write}}
@d pdf_pages_attr_text  = 17 {|token_type| code for \.{\\pdfpagesattr}}
@d pdf_page_attr_text  = 18 {|token_type| code for \.{\\pdfpageattr}}
@d pdf_page_resources_text = 19 {|token_type| code for \.{\\pdfpageresources}}
@y
@d token_list=0 {|state| code when scanning a token list}
@d token_type==index {type of current token list}
@d param_start==limit {base of macro parameters in |param_stack|}
@d parameter=0 {|token_type| code for parameter}
@d u_template=1 {|token_type| code for \<u_j> template}
@d v_template=2 {|token_type| code for \<v_j> template}
@d backed_up=3 {|token_type| code for text to be reread}
@d inserted=4 {|token_type| code for inserted texts}
@d list_insert=5 {|token_type| code for list expansions}
@d list_scan=6 {|token_type| code for scanned lists}
@d macro=7 {|token_type| code for defined control sequences}
@d output_text=8 {|token_type| code for output routines}
@d every_par_text=9 {|token_type| code for \.{\\everypar}}
@d every_math_text=10 {|token_type| code for \.{\\everymath}}
@d every_display_text=11 {|token_type| code for \.{\\everydisplay}}
@d every_hbox_text=12 {|token_type| code for \.{\\everyhbox}}
@d every_vbox_text=13 {|token_type| code for \.{\\everyvbox}}
@d every_job_text=14 {|token_type| code for \.{\\everyjob}}
@d every_cr_text=15 {|token_type| code for \.{\\everycr}}
@d every_eof_text=16 {|token_type| code for \.{\\everyeof}}
@d mark_text=17 {|token_type| code for \.{\\topmark}, etc.}
@d write_text=18 {|token_type| code for \.{\\write}}
@d pdf_pages_attr_text  = 19 {|token_type| code for \.{\\pdfpagesattr}}
@d pdf_page_attr_text  = 20 {|token_type| code for \.{\\pdfpageattr}}
@d pdf_page_resources_text = 21 {|token_type| code for \.{\\pdfpageresources}}
@z

@x l.7054
@ @<Print type of token list@>=
case token_type of
parameter: print_nl("<argument> ");
u_template,v_template: print_nl("<template> ");
backed_up: if loc=null then print_nl("<recently read> ")
  else print_nl("<to be read again> ");
inserted: print_nl("<inserted text> ");
macro: begin print_ln; print_cs(name);
  end;
output_text: print_nl("<output> ");
every_par_text: print_nl("<everypar> ");
every_math_text: print_nl("<everymath> ");
every_display_text: print_nl("<everydisplay> ");
every_hbox_text: print_nl("<everyhbox> ");
every_vbox_text: print_nl("<everyvbox> ");
every_job_text: print_nl("<everyjob> ");
every_cr_text: print_nl("<everycr> ");
every_eof_text: print_nl("<everyeof> ");
mark_text: print_nl("<mark> ");
write_text: print_nl("<write> ");
@y
@ @<Print type of token list@>=
case token_type of
parameter: print_nl("<argument> ");
u_template,v_template: print_nl("<template> ");
backed_up: if loc=null then print_nl("<recently read> ")
  else print_nl("<to be read again> ");
inserted: print_nl("<inserted text> ");
list_insert: print_nl("<list expansion> ");
list_scan: print_nl("<scanned list> ");
macro: begin print_ln; print_cs(name);
  end;
output_text: print_nl("<output> ");
every_par_text: print_nl("<everypar> ");
every_math_text: print_nl("<everymath> ");
every_display_text: print_nl("<everydisplay> ");
every_hbox_text: print_nl("<everyhbox> ");
every_vbox_text: print_nl("<everyvbox> ");
every_job_text: print_nl("<everyjob> ");
every_cr_text: print_nl("<everycr> ");
every_eof_text: print_nl("<everyeof> ");
mark_text: print_nl("<mark> ");
write_text: print_nl("<write> ");
@z

@x l.7226
@p procedure end_token_list; {leave a token-list input level}
begin if token_type>=backed_up then {token list to be deleted}
  begin if token_type<=inserted then flush_list(start)
  else  begin delete_token_ref(start); {update reference count}
    if token_type=macro then {parameters must be flushed}
      while param_ptr>param_start do
        begin decr(param_ptr);
        flush_list(param_stack[param_ptr]);
        end;
    end;
  end
else if token_type=u_template then
  if align_state>500000 then align_state:=0
  else fatal_error("(interwoven alignment preambles are not allowed)");
@.interwoven alignment preambles...@>
pop_input;
check_interrupt;
end;
@y
@p procedure end_token_list; {leave a token-list input level}
begin if token_type>=backed_up then {token list to be deleted}
  begin if token_type<macro then flush_list(start)
  else  begin delete_token_ref(start); {update reference count}
    if token_type=macro then {parameters must be flushed}
      while param_ptr>param_start do
        begin decr(param_ptr);
        flush_list(param_stack[param_ptr]);
        end;
    end;
  end
else if token_type=u_template then
  if align_state>500000 then align_state:=0
  else fatal_error("(interwoven alignment preambles are not allowed)");
@.interwoven alignment preambles...@>
pop_input;
check_interrupt;
end;
@z

@x l.7643
@ Control sequence names are scanned only when they appear in some line of
a file; once they have been scanned the first time, their |eqtb| location
serves as a unique identification, so \TeX\ doesn't need to refer to the
original name any more except when it prints the equivalent in symbolic form.

The program that scans a control sequence has been written carefully
in order to avoid the blowups that might otherwise occur if a malicious
user tried something like `\.{\\catcode\'15=0}'. The algorithm might
look at |buffer[limit+1]|, but it never looks at |buffer[limit+2]|.

If expanded characters like `\.{\^\^A}' or `\.{\^\^df}'
appear in or just following
a control sequence name, they are converted to single characters in the
buffer and the process is repeated, slowly but surely.

@<Scan a control...@>=
begin if loc>limit then cur_cs:=null_cs {|state| is irrelevant in this case}
else  begin start_cs: k:=loc; cur_chr:=buffer[k]; cat:=cat_code(cur_chr);
  incr(k);
  if cat=letter then state:=skip_blanks
  else if cat=spacer then state:=skip_blanks
  else state:=mid_line;
  if (cat=letter)and(k<=limit) then
    @<Scan ahead in the buffer until finding a nonletter;
    if an expanded code is encountered, reduce it
    and |goto start_cs|; otherwise if a multiletter control
    sequence is found, adjust |cur_cs| and |loc|, and
    |goto found|@>
  else @<If an expanded code is present, reduce it and |goto start_cs|@>;
  cur_cs:=single_base+buffer[loc]; incr(loc);
  end;
found: cur_cmd:=eq_type(cur_cs); cur_chr:=equiv(cur_cs);
if cur_cmd>=outer_call then check_outer_validity;
end
@y
@ Control sequence names are scanned only when they appear in some line of
a file; once they have been scanned the first time, their |eqtb| location
serves as a unique identification, so \TeX\ doesn't need to refer to the
original name any more except when it prints the equivalent in symbolic form.

The program that scans a control sequence has been written carefully
in order to avoid the blowups that might otherwise occur if a malicious
user tried something like `\.{\\catcode\'15=0}'. The algorithm might
look at |buffer[limit+1]|, but it never looks at |buffer[limit+2]|.

If expanded characters like `\.{\^\^A}' or `\.{\^\^df}'
appear in or just following
a control sequence name, they are converted to single characters in the
buffer and the process is repeated, slowly but surely.

@<Scan a control...@>=
begin 
if loc>limit then cur_cs:=null_cs {|state| is irrelevant in this case}
else  begin start_cs: 
  k:=loc; cur_chr:=buffer[k]; cat:=cat_code(cur_chr);
  incr(k);
  if sgml_mode=0 then begin
    if cat=letter then state:=skip_blanks
    else if cat=spacer then state:=skip_blanks
    else state:=mid_line;
    if (cat=letter)and(k<=limit) then
      @<Scan ahead in the buffer until finding a nonletter;
      if an expanded code is encountered, reduce it
      and |goto start_cs|; otherwise if a multiletter control
      sequence is found, adjust |cur_cs| and |loc|, and
      |goto found|@>
    else @<If an expanded code is present, reduce it and |goto start_cs|@>;
    cur_cs:=single_base+buffer[loc]; incr(loc);
  end
  else begin
    if cat=letter then state:=skip_blanks
    else if cat=spacer then state:=skip_blanks
    else state:=mid_line;
    if (cat<>spacer)and(k<=limit) then
      @<Scan for a space or closer;
       if a multiletter control
      sequence is found, adjust |cur_cs| and |loc|, and
      |goto found|@>
    else @<If an expanded code is present, reduce it and |goto start_cs|@>;
    @<Set |c| to the closer@>;
    cur_cs:=single_base+buffer[loc]; 
    incr(loc);
    @<Gobble closer if there is one@>;
  end;
  end;
found: cur_cmd:=eq_type(cur_cs); cur_chr:=equiv(cur_cs);
if cur_cmd>=outer_call then check_outer_validity;
end
@z


@x [25] m.366 l.7941
if cur_cmd<call then @<Expand a nonmacro@>
else if cur_cmd<end_template then macro_call
else @<Insert a token containing |frozen_endv|@>;
cur_val:=cv_backup; cur_val_level:=cvl_backup; radix:=radix_backup;
cur_order:=co_backup; link(backup_head):=backup_backup;
end;
@y
if cur_cmd<list_call then @<Expand a nonmacro@>
else if cur_cmd=list_call then expand_list
else if cur_cmd<end_template then macro_call
else @<Insert a token containing |frozen_endv|@>;
cur_val:=cv_backup; cur_val_level:=cvl_backup; radix:=radix_backup;
cur_order:=co_backup; link(backup_head):=backup_backup;
end;
@z

@x l.8869
@d eTeX_int=glue_val+14 {first of \eTeX\ codes for integers}
@d eTeX_dim=eTeX_int+8 {first of \eTeX\ codes for dimensions}
@d eTeX_glue=eTeX_dim+9 {first of \eTeX\ codes for glue}
@d eTeX_mu=eTeX_glue+1 {first of \eTeX\ codes for muglue}
@d eTeX_expr=eTeX_mu+1 {first of \eTeX\ codes for expressions}
@y
@d eTeX_int=glue_val+14 {first of \eTeX\ codes for integers}
@d eTeX_dim=eTeX_int+13 {first of \eTeX\ codes for dimensions}
@d eTeX_glue=eTeX_dim+9 {first of \eTeX\ codes for glue}
@d eTeX_mu=eTeX_glue+1 {first of \eTeX\ codes for muglue}
@d eTeX_expr=eTeX_mu+1 {first of \eTeX\ codes for expressions}
@z

@x [26] m.440 l.9047
@p procedure scan_int; {sets |cur_val| to an integer}
label done;
var negative:boolean; {should the answer be negated?}
@!m:integer; {|@t$2^{31}$@> div radix|, the threshold of danger}
@!d:small_number; {the digit just scanned}
@!vacuous:boolean; {have no digits appeared?}
@!OK_so_far:boolean; {has an error message been issued?}
begin radix:=0; OK_so_far:=true;@/
@<Get the next non-blank non-sign token; set |negative| appropriately@>;
if cur_tok=alpha_token then @<Scan an alphabetic character code into |cur_val|@>
else if (cur_cmd>=min_internal)and(cur_cmd<=max_internal) then
  scan_something_internal(int_val,false)
else @<Scan a numeric constant@>;
if negative then negate(cur_val);
end;
@y
@p procedure scan_int; {sets |cur_val| to an integer}
label done;
var negative:boolean; {should the answer be negated?}
@!m:integer; {|@t$2^{31}$@> div radix|, the threshold of danger}
@!d:small_number; {the digit just scanned}
@!vacuous:boolean; {have no digits appeared?}
@!OK_so_far:boolean; {has an error message been issued?}
begin radix:=0; OK_so_far:=true;@/
@<Get the next non-blank non-sign token; set |negative| appropriately@>;
if cur_cmd=list_call then @<Fetch the length of a list@> 
else if cur_tok=alpha_token then @<Scan an alphabetic character code into |cur_val|@>
else if (cur_cmd>=min_internal)and(cur_cmd<=max_internal) then
  scan_something_internal(int_val,false)
else @<Scan a numeric constant@>;
if negative then negate(cur_val);
end;
@z

@x [26] m.441 l.9063
@ @<Get the next non-blank non-sign token...@>=
negative:=false;
repeat @<Get the next non-blank non-call token@>;
if cur_tok=other_token+"-" then
  begin negative := not negative; cur_tok:=other_token+"+";
  end;
until cur_tok<>other_token+"+"
@y
@ @<Get the next non-blank non-sign token...@>=
negative:=false;
repeat 
		repeat get_next;
		if cur_cmd<>list_call then x_token
		else cur_tok:=cur_cmd; {lack of expansion hack}
		until cur_cmd<>spacer;
if cur_tok=other_token+"-" then
  begin negative := not negative; cur_tok:=other_token+"+";
  end;
until cur_tok<>other_token+"+"
@z

@x l.9354

@d set_conversion_end(#)== denom:=#; end
@d set_conversion(#)==@+begin num:=#; set_conversion_end

@<Scan for \(a)all other units and adjust |cur_val| and |f|...@>=
if scan_keyword("in") then set_conversion(7227)(100)
@.in@>
else if scan_keyword("pc") then set_conversion(12)(1)
@.pc@>
else if scan_keyword("cm") then set_conversion(7227)(254)
@.cm@>
else if scan_keyword("mm") then set_conversion(7227)(2540)
@.mm@>
else if scan_keyword("bp") then set_conversion(7227)(7200)
@.bp@>
else if scan_keyword("dd") then set_conversion(1238)(1157)
@.dd@>
else if scan_keyword("cc") then set_conversion(14856)(1157)
@.cc@>
else if scan_keyword("sp") then goto done
@.sp@>
else @<Complain about unknown unit and |goto done2|@>;
cur_val:=xn_over_d(cur_val,num,denom);
f:=(num*f+@'200000*remainder) div denom;@/
cur_val:=cur_val+(f div @'200000); f:=f mod @'200000;
done2:
@y

Eetex recognizes two new types of dimensions: \.{px} and \.{\%}.  A
\.{px} corresponds to a pixel, with a resolution of 96 dots per
inch. The \.{\%} is introduced because mathml uses it. It's easier to
feed attribute values to |scan_dimen| if all possible code is
accepted. But setting up \.{\%} in a meaningful way is quite tricky,
so the current implementation maps \.{\%} to \.{sp}.

@d set_conversion_end(#)== denom:=#; end
@d set_conversion(#)==@+begin num:=#; set_conversion_end

@<Scan for \(a)all other units and adjust |cur_val| and |f|...@>=
if scan_keyword("in") then set_conversion(7227)(100)
@.in@>
else if scan_keyword("pc") then set_conversion(12)(1)
@.pc@>
else if scan_keyword("cm") then set_conversion(7227)(254)
@.cm@>
else if scan_keyword("mm") then set_conversion(7227)(2540)
@.mm@>
else if scan_keyword("bp") then set_conversion(7227)(7200)
@.bp@>
else if scan_keyword("dd") then set_conversion(1238)(1157)
@.dd@>
else if scan_keyword("cc") then set_conversion(14856)(1157)
@.cc@>
else if scan_keyword("px") then set_conversion(7227)(9600)
@.px@>
else if scan_keyword("sp") then goto done
@.sp@>
else if scan_keyword("%") then goto done
@.%@>
else @<Complain about unknown unit and |goto done2|@>;
cur_val:=xn_over_d(cur_val,num,denom);
f:=(num*f+@'200000*remainder) div denom;@/
cur_val:=cur_val+(f div @'200000); f:=f mod @'200000;
done2:
@z

@x l.10213
@<Test if two tokens match@>=
begin save_scanner_status:=scanner_status; scanner_status:=normal;
get_next; n:=cur_cs; p:=cur_cmd; q:=cur_chr;
get_next; if cur_cmd<>p then b:=false
else if cur_cmd<call then b:=(cur_chr=q)
else @<Test if two macro texts match@>;
scanner_status:=save_scanner_status;
end
@y
@<Test if two tokens match@>=
begin save_scanner_status:=scanner_status; scanner_status:=normal;
get_next; n:=cur_cs; p:=cur_cmd; q:=cur_chr;
get_next; if cur_cmd<>p then b:=false
else if cur_cmd<list_call then b:=(cur_chr=q)
else if cur_cmd=list_call then @<Test if two list texts match@>
else @<Test if two macro texts match@>;
scanner_status:=save_scanner_status;
end
@z

@x [49] m.1209 l.23227
def: if chr_code=0 then print_esc("def")
  else if chr_code=1 then print_esc("gdef")
  else if chr_code=2 then print_esc("edef")
  else print_esc("xdef");
@y
def: if chr_code=0 then print_esc("def")
  else if chr_code=1 then print_esc("gdef")
  else if chr_code=2 then print_esc("edef")
  else if chr_code=3 then print_esc("xdef")
  @<Cases of eetex extensions to |def|@>;
@z

@x l.23269
@ If the user says, e.g., `\.{\\global\\global}', the redundancy is
silently accepted.

@<Declare act...@>=
@t\4@>@<Declare subprocedures for |prefixed_command|@>@t@>@;@/
procedure prefixed_command;
label done,exit;
var a:small_number; {accumulated prefix codes so far}
@y
@ If the user says, e.g., `\.{\\global\\global}', the redundancy is
silently accepted.

@<Declare act...@>=
@t\4@>@<Declare subprocedures for |prefixed_command|@>@t@>@;@/
procedure prefixed_command;
label done,exit;
var a:small_number; {accumulated prefix codes so far}
@!r,@!s,@!v,@!b:pointer; {scratch pointers needed for list item manipulation}
@!boundserr:boolean;
@z

@x [49] m.1218 l.23370
@ When a |def| command has been scanned,
|cur_chr| is odd if the definition is supposed to be global, and
|cur_chr>=2| if the definition is supposed to be expanded.

@<Assignments@>=
def: begin if odd(cur_chr)and not global and(global_defs>=0) then a:=a+4;
  e:=(cur_chr>=2); get_r_token; p:=cur_cs;
  q:=scan_toks(true,e);
  if j<>0 then
    begin q:=get_avail; info(q):=j; link(q):=link(def_ref);
    link(def_ref):=q;
    end;
  define(p,call+(a mod 4),def_ref);
  end;
@y
@ When a |def| command has been scanned,
|cur_chr| is odd if the definition is supposed to be global, and
|cur_chr>=2| if the definition is supposed to be expanded.

@<Assignments@>=
def: if cur_chr >= 4 then 
  @<Handle definition primitives for eetex@>
  else
  begin if odd(cur_chr)and not global and(global_defs>=0) then a:=a+4;
  e:=(cur_chr>=2); get_r_token; p:=cur_cs;
  q:=scan_toks(true,e);
  if j<>0 then
    begin q:=get_avail; info(q):=j; link(q):=link(def_ref);
    link(def_ref):=q;
    end;
  define(p,call+(a mod 4),def_ref);
  end;
@z

@x l.23493
    skip_def_code: define(p,assign_glue,skip_base+cur_val);
    mu_skip_def_code: define(p,assign_mu_glue,mu_skip_base+cur_val);
    toks_def_code: define(p,assign_toks,toks_base+cur_val);
    end; {there are no other cases}
    end
  endcases;
  end;

@ @<Assignments@>=
read_to_cs: begin j:=cur_chr; scan_int; n:=cur_val;
  if not scan_keyword("to") then
    begin print_err("Missing `to' inserted");
@.Missing `to'...@>
    help2("You should have said `\read<number> to \cs'.")@/
    ("I'm going to look for the \cs now."); error;
    end;
  get_r_token;
  p:=cur_cs; read_toks(n,p,j); define(p,call,cur_val);
  end;
@y
    skip_def_code: define(p,assign_glue,skip_base+cur_val);
    mu_skip_def_code: define(p,assign_mu_glue,mu_skip_base+cur_val);
    toks_def_code: define(p,assign_toks,toks_base+cur_val);
    end; {there are no other cases}
    end
  endcases;
  end;

@ @<Assignments@>=
read_to_cs: if cur_chr < 2 then 
  begin j:=cur_chr; scan_int; n:=cur_val;
    if not scan_keyword("to") then
      begin print_err("Missing `to' inserted");
@.Missing `to'...@>
      help2("You should have said `\read<number> to \cs'.")@/
      ("I'm going to look for the \cs now."); error;
      end;
    get_r_token;
    p:=cur_cs; read_toks(n,p,j); define(p,call,cur_val);
  end else
@<Handle |read_to_cs| for eetex@>;
@z

@x l. 29986
@d pdf_map_file_code          == 33
@y
@d pdf_map_file_code          == 33
@d packed_node                == 34
@z

@x l. 30064 
@ @<Cases of |print_cmd_chr|...@>=
extension: case chr_code of
  open_node:print_esc("openout");
  write_node:print_esc("write");
  close_node:print_esc("closeout");
  special_node:print_esc("special");
  immediate_code:print_esc("immediate");
  set_language_code: print_esc("setlanguage");
@y
@ @<Cases of |print_cmd_chr|...@>=
extension: case chr_code of
  open_node:print_esc("openout");
  write_node:print_esc("write");
  close_node:print_esc("closeout");
  special_node:print_esc("special");
  packed_node:print_esc("packed");
  immediate_code:print_esc("immediate");
  set_language_code:print_esc("setlanguage");
@z

@x
@ @<Declare act...@>=
@t\4@>@<Declare procedures needed in |do_extension|@>@;
procedure do_extension;
var i,@!j,@!k:integer; {all-purpose integers}
@!p,@!q,@!r:pointer; {all-purpose pointers}
begin case cur_chr of
open_node:@<Implement \.{\\openout}@>;
write_node:@<Implement \.{\\write}@>;
close_node:@<Implement \.{\\closeout}@>;
special_node:@<Implement \.{\\special}@>;
immediate_code:@<Implement \.{\\immediate}@>;
set_language_code: @<Implement \.{\\setlanguage}@>;
@y
@ @<Declare act...@>=
@t\4@>@<Declare procedures needed in |do_extension|@>@;
procedure do_extension;
var i,@!j,@!k:integer; {all-purpose integers}
@!p,@!q,@!r:pointer; {all-purpose pointers}
begin case cur_chr of
open_node:@<Implement \.{\\openout}@>;
write_node:@<Implement \.{\\write}@>;
close_node:@<Implement \.{\\closeout}@>;
special_node:@<Implement \.{\\special}@>;
packed_node:@<Implement \.{\\packed}@>;
immediate_code:@<Implement \.{\\immediate}@>;
set_language_code:@<Implement \.{\\setlanguage}@>;
@z

@x
@ @<Display the whatsit...@>=
case subtype(p) of
open_node:begin print_write_whatsit("openout",p);
  print_char("="); print_file_name(open_name(p),open_area(p),open_ext(p));
  end;
write_node:begin print_write_whatsit("write",p);
  print_mark(write_tokens(p));
  end;
close_node:print_write_whatsit("closeout",p);
special_node:begin print_esc("special");
  print_mark(write_tokens(p));
  end;
language_node:begin print_esc("setlanguage");
  print_int(what_lang(p)); print(" (hyphenmin ");
  print_int(what_lhm(p)); print_char(",");
  print_int(what_rhm(p)); print_char(")");
  end;
@y
@ @<Display the whatsit...@>=
case subtype(p) of
open_node:begin print_write_whatsit("openout",p);
  print_char("="); print_file_name(open_name(p),open_area(p),open_ext(p));
  end;
write_node:begin print_write_whatsit("write",p);
  print_mark(write_tokens(p));
  end;
close_node:print_write_whatsit("closeout",p);
special_node:begin print_esc("special");
  print_mark(write_tokens(p));
  end;
packed_node:begin print_esc("packed");
  print_mark(write_tokens(p));
  end;
language_node:begin print_esc("setlanguage");
  print_int(what_lang(p)); print(" (hyphenmin ");
  print_int(what_lhm(p)); print_char(",");
  print_int(what_rhm(p)); print_char(")");
  end;
@z


@x
@ @<Make a partial copy of the whatsit...@>=
case subtype(p) of
open_node: begin r:=get_node(open_node_size); words:=open_node_size;
  end;
write_node,special_node: begin r:=get_node(write_node_size);
  add_token_ref(write_tokens(p)); words:=write_node_size;
  end;
close_node,language_node: begin r:=get_node(small_node_size);
  words:=small_node_size;
  end;
@y
@ @<Make a partial copy of the whatsit...@>=
case subtype(p) of
open_node: begin r:=get_node(open_node_size); words:=open_node_size;
  end;
write_node,special_node,packed_node: begin r:=get_node(write_node_size);
  add_token_ref(write_tokens(p)); words:=write_node_size;
  end;
close_node,language_node: begin r:=get_node(small_node_size);
  words:=small_node_size;
  end;
@z

@x
@ @<Wipe out the whatsit...@>=
begin case subtype(p) of
open_node: free_node(p,open_node_size);
write_node,special_node: begin delete_token_ref(write_tokens(p));
  free_node(p,write_node_size); goto done;
  end;
close_node,language_node: free_node(p,small_node_size);
@y
@ @<Wipe out the whatsit...@>=
begin case subtype(p) of
open_node: free_node(p,open_node_size);
write_node,special_node,packed_node: 
  begin free_node(p,write_node_size); goto done;
  end;
close_node,language_node: free_node(p,small_node_size);
@z

@x
@ The |out_what| procedure takes care of outputting whatsit nodes for
|vlist_out| and |hlist_out|\kern-.3pt.

@<Declare procedures needed in |hlist_out|, |vlist_out|@>=
procedure out_what(@!p:pointer);
var j:small_number; {write stream number}
begin case subtype(p) of
open_node,write_node,close_node:@<Do some work that has been queued up
  for \.{\\write}@>;
special_node:special_out(p);
language_node:do_nothing;
othercases confusion("ext4")
@:this can't happen ext4}{\quad ext4@>
endcases;
end;
@y
@ The |out_what| procedure takes care of outputting whatsit nodes for
|vlist_out| and |hlist_out|\kern-.3pt.

@<Declare procedures needed in |hlist_out|, |vlist_out|@>=
@<Declare procedures needed for packed output@>
procedure out_what(@!p:pointer);
var j:small_number; {write stream number}
begin case subtype(p) of
open_node,write_node,close_node:@<Do some work that has been queued up
  for \.{\\write}@>;
special_node:special_out(p);
packed_node:packed_out(p);
language_node:do_nothing;
othercases confusion("ext4")
@:this can't happen ext4}{\quad ext4@>
endcases;
end;
@z

@x
@ The \eTeX\ features available in extended mode are grouped into two
categories:  (1)~Some of them are permanently enabled and have no
semantic effect as long as none of the additional primitives are
executed.  (2)~The remaining \eTeX\ features are optional and can be
individually enabled and disabled.  For each optional feature there is
an \eTeX\ state variable named \.{\\...state}; the feature is enabled,
resp.\ disabled by assigning a positive, resp.\ non-positive value to
that integer.

@d eTeX_state_base=int_base+eTeX_state_code
@d eTeX_state(#)==eqtb[eTeX_state_base+#].int {an \eTeX\ state variable}
@#
@d eTeX_version_code=eTeX_int {code for \.{\\eTeXversion}}
@d eTeX_revision_code=6 {command code for \.{\\eTeXrevision}}
@y
@ The \eTeX\ features available in extended mode are grouped into two
categories:  (1)~Some of them are permanently enabled and have no
semantic effect as long as none of the additional primitives are
executed.  (2)~The remaining \eTeX\ features are optional and can be
individually enabled and disabled.  For each optional feature there is
an \eTeX\ state variable named \.{\\...state}; the feature is enabled,
resp.\ disabled by assigning a positive, resp.\ non-positive value to
that integer.

@d eTeX_state_base=int_base+eTeX_state_code
@d eTeX_state(#)==eqtb[eTeX_state_base+#].int {an \eTeX\ state variable}
@#
@d eTeX_version_code=eTeX_int {code for \.{\\eTeXversion}}
@d eTeX_revision_code=6 {command code for \.{\\eTeXrevision}}
@d eeTeX_version_code=eTeX_int+8 {code for \.{\\eeTeXversion}}
@d item_call_code=eTeX_int+9 {code for \.{\\itemnumber}}
@d subitem_call_code=eTeX_int+10 {code for \.{\\subitemnumber}}
@d lastitem_number_code=eTeX_int+11 {code for \.{\\lastitemnumber}}
@d lastitem_data_code=eTeX_int+12 {code for \.{\\lastitemdata}}
@z

@x l.27102
@ @<Cases of |read| for |print_cmd_chr|@>=
else print_esc("readline")
@y
@ @<Cases of |read| for |print_cmd_chr|@>=
else if chr_code = 1 then print_esc("readline")
else @<Cases of |read_to_cs| for eetex@>
@z

@x [54] m.1379 l.24903 - e-TeX additions
@* \[54] System-dependent changes.
@y
@* \[53b] The extended features of ee\TeX.

@ @<Generate all \eTeX...@>=
primitive("eeTeXversion",last_item,eeTeX_version_code);
@!@:eeTeX_version_}{\.{\\eeTeXversion} primitive@>

@ @<Cases of |last_item| for |print_cmd_chr|@>=
eeTeX_version_code: print_esc("eeTeXversion");

@ @<Cases for fetching an integer value@>=
eeTeX_version_code: cur_val:=eeTeX_version;

@ @<Generate all \eTeX...@>=
primitive("sgmlmode",assign_int,int_base+sgml_mode_code);
@!@:sgml_mode_}{\.{\\sgmlmode} primitive@>

@ @<Generate all \eTeX...@>=
primitive("listdef",def,4);
@!@:listdef_}{\.{\\listdef} primitive@>
primitive("elistdef",def,5);
@!@:listdef_}{\.{\\elistdef} primitive@>
primitive("appdef",def,6);
@!@:appdef_}{\.{\\appdef} primitive@>
primitive("eappdef",def,7);
@!@:appdef_}{\.{\\eappdef} primitive@>
primitive("predef",def,8);
@!@:predef_}{\.{\\predef} primitive@>
primitive("epredef",def,9);
@!@:predef_}{\.{\\epredef} primitive@>
primitive("insdef",def,10);
@!@:insdef_}{\.{\\insdef} primitive@>
primitive("einsdef",def,11);
@!@:insdef_}{\.{\\einsdef} primitive@>
primitive("newlist",def,12);
@!@:setlistlength_}{\.{\\newlist} primitive@>
primitive("quitlist",def,13);
@!@:quit_list_}{\.{\\quitlist} primitive@>
primitive("apptoks",def,14);
@!@:apptoks_}{\.{\\apptoks} primitive@>
primitive("pretoks",def,15);
@!@:pretoks_}{\.{\\pretoks} primitive@>

@ @<Cases of eetex extensions to |def|@>=
else if chr_code=4 then print_esc("listdef")
else if chr_code=5 then print_esc("elistdef")
else if chr_code=6 then print_esc("appdef")
else if chr_code=7 then print_esc("eappdef")
else if chr_code=8 then print_esc("predef")
else if chr_code=9 then print_esc("epredef")
else if chr_code=10 then print_esc("insdef")
else if chr_code=11 then print_esc("einsdef")
else if chr_code=12 then print_esc("newlist")
else if chr_code=13 then print_esc("quitlist")
else if chr_code=14 then print_esc("apptoks")
else if chr_code=15 then print_esc("pretoks")

@ @<Cases of |print_cmd_chr|...@>=
list_call: begin 
	print("list");
	end;


@ Ee\TeX\ uses values 4 and larger for the new primitives 
for lists and dictionaries. They always come in pairs: the 
versions with even numbers in |cur_chr| are always the
non-expanded version, the odd numbers the expanded version.
There are no separate commands for \.{\\global}, but the 
value of the prefix is taken into account; because the
program will eventually call |define| with the value of 
|a| unchanged.
@d memtraceup(#)== if tracing_stats>3 then begin 
	print_nl("{mem plus "); print_int(#); print("}"); end
@d memtracedown(#)== if tracing_stats>3 then begin 
	print_nl("{mem minus "); print_int(#); print("}"); end
@d startmemtrace(#)== if tracing_stats>2 then
  	begin print_nl("{mem usage before ");
  	print(#); print(": "); print_int(dyn_used); end
@d stopmemtrace== if tracing_stats>2 then begin 
  	print(" after: "); print_int(dyn_used); print_char("}"); end

@<Handle definition primitives for eetex@>=
begin
list_xpand := odd(cur_chr); {expanded?}
if (cur_chr<=12) then begin
   if (cur_chr=4) or (cur_chr=5) then begin 
	   get_r_token;
   	   p:=cur_cs;
	   def_list;
   end;
   if (cur_chr=6) or (cur_chr=7) then begin 
	   get_r_token;
   	   p:=cur_cs;
	   app_list;
   end;
   if (cur_chr=8) or (cur_chr=9) then begin 
	   get_r_token;
   	   p:=cur_cs;
	   pre_list;
   end;
   if (cur_chr=10) or (cur_chr=11) then begin 
	   get_r_token;
   	   p:=cur_cs;
	   uins_list;
   end;
   if (cur_chr=12) then begin 
	   get_r_token;
   	   p:=cur_cs;
	   resize_list;
   end;
   define(p,list_call,def_ref);
   end
else if cur_chr = 13 then begin
      scan_int;
	  @<Kill off a list@>;
   end
else if (cur_chr=14) then begin
       listitemcheck:=a; 
   	   app_toks;
       listitemcheck:=0;
   end
else if (cur_chr=15) then begin 
       listitemcheck:=a; 
   	   pre_toks;
       listitemcheck:=0;
   end;
end

@ @<Declare \eTeX\ procedures for sc...@>=
function the_list:pointer;
var a,@!b,@!r,@!s,@!p,@!q:pointer; 
@!lengthl:halfword; {length}
begin
  while (state=token_list)and(loc=null) do end_token_list; 
  r:=equiv(cur_cs); 
  lengthl:=info(r);
  b:=null;
  if lengthl <> 0 then begin
	a:=get_avail;
	info(a):=0; {deletion problems}
	s:=a;
	while lengthl > 0 do begin
      r:=link(r);
      decr(lengthl);
      if info(r)<>0 then begin
         p:=info(r);
         @<insert an item in the input@>;
         if lengthl > 0 then begin
           p:=list_sep;
           if (p<>0) then begin
             while link(p)<>null do begin
               p:=link(p);
               b:=get_avail;
    		   info(a):=info(p);
               link(a):=b;
               q:=a; a:=b;
             end;
           end;
	     end;
      end;
    end;
    if b=null then s:=0 else begin
      a:=q;
      link(a):=null;
      free_avail(b);
    end;
  end else begin {zero items}
    s:=0;
  end;
  the_list:=s;
end;

procedure show_the_list;
var s:pointer;
begin;
startmemtrace("showthelist");
  s:=the_list;
  show_token_list(s,null,32);
  if s then flush_list(s);
stopmemtrace;
end;

procedure expand_list;
var s:pointer;
begin;
startmemtrace("expandlist");
  s:=the_list;
  if s then begin_token_list(s,list_insert) 
  else begin 
     s:=get_avail;
	 memtraceup(1);	
     info(s):=cs_token_flag+frozen_relax;
	 link(s):=null; 
  end; 
stopmemtrace;
end;

@ @<insert an item in the input@>=
while (info(p)<>end_match_token) and (link(p)<>null) do begin
p:=link(p);
end;
while link(p)<>null do begin
     p:=link(p);
     b:=get_avail;
     memtraceup(1);
	 info(a):=info(p);
     link(a):=b;
     q:=a; a:=b;
end
      

@ @<Fetch the length of a list@>=  
begin
  vacuous:=false;	
  cur_val:=info(equiv(cur_cs));
end

@ @<Glob...@>=
@!list_xpand:boolean; {do we want expanded lists?}
@ @<Set init...@>=
list_xpand:=false;

@ @<Declare \eTeX\ procedures for tok...@>=
procedure@?def_list; forward;@t\2@>
procedure@?app_list; forward;@t\2@>
procedure@?pre_list; forward;@t\2@>
procedure@?uins_list; forward;@t\2@>
procedure@?resize_list; forward;@t\2@>
procedure@?scan_list; forward;@t\2@>
procedure@?app_toks; forward;@t\2@>
procedure@?pre_toks; forward;@t\2@>


@ This is deflist.

@p procedure def_list;
label restart,found,done,done2;
var l:pointer; {for item separator}
p,q:pointer; {items being built through |store_new_token|}
r,s:pointer; {start and tail of the list being built}
v:pointer; {to save |s| in the |define| trick}
a,b:pointer; {spare pointers?}
unbalance:halfword; {number of unmatched left braces}
@!lengthl:halfword; {length of this list so far}
seentok:boolean; {seen a token?}
save_scanner_status:small_number; {temporary storage of |scanner_status|}
begin
save_scanner_status:=scanner_status; scanner_status:=defining; 
startmemtrace("listdef");
warning_index:=cur_cs; 
lengthl:=0; 
seentok:=false;
r:=null;
@<Check for legal input and get next token@>;
if cur_cmd = left_brace then begin
  @<Do the argument parsing that all list defs have in common@>;
end else begin 
  @<Insert list that already existed before@>;
end;
found: 
if not seentok then begin  {create dummy list with 0 items}
if r=null then begin
  r:=get_avail;
  memtraceup(1);
  info(r):=0;
  end;
end;
def_ref:=r;
scanner_status:=save_scanner_status;
stopmemtrace;
end;

@ The next non-blank token should be either the name of a list 
that will be used more or less as-is, or it should be a left brace 
to start a list of literal items.

@<Check for legal input and get next token@>=
repeat get_token;
  until (cur_cmd<>spacer);
if (cur_cmd<>left_brace)and(cur_cmd<>list_call) then
  begin print_err("Missing { inserted");
@.Missing \{ inserted@>
  help4("A left brace or a list's csname was mandatory here.")@/
    ("You might want to delete and/or insert some corrections")@/
    ("so that I will find a matching right brace soon.")@/
    ("(If you're confused by all this, try typing `I}' now.)");
  back_error; cur_tok:=left_brace_token+"{"; cur_cmd:=left_brace;
  cur_chr:="{"; incr(align_state);
  end


@ @<Insert list that already existed before@>=
  seentok:=true;
  p:=equiv(cur_cs); 
  lengthl:=info(p);
  r:=get_avail;
  memtraceup(1);
  info(r):=lengthl;
  link(r):=null;
  if lengthl = 0 then goto found;
  q:=r;
  while (lengthl>0) do begin
  	decr(lengthl);
	p:=link(p);
    s:=get_avail;
    memtraceup(1);
	link(q):=s;
	info(s):=info(p);
	link(s):=null;
	incr(token_ref_count(info(p)));
	q:=s;
  end


@ This subroutine needed some cleaning up. The logic is now as follows: it 
uses |r| and |s| to store a completely new list in. |p| and |q| are needed 
for the addition of new items by |store_new_token|. 
|seentok| will be set true if there was a 
usable token in the user input; otherwise it will remain false, and
in that case |r| and |s| are undefined. |l| is used to store the current
|list_sep|. 

The "Scan ahead" will call |free_avail| to get rid of the three nodes 
if they are not needed. The code following that module can be sure
that there will be at least one item, so the next token will be the 
start of the first item.

"Expand the next..." might clutter |p| and |q|. Needs checking. 
@d start_an_item == p:=get_avail; link(s):=p; s:=p; 
      p:=get_avail; token_ref_count(p):=0; info(s):=p;
      link(p):=get_avail; p:=link(p); info(p):=end_match_token;
	  memtraceup(3)

@<Do the argument parsing that all list defs have in common@>=
unbalance:=1;
r:=get_avail; { info(r) will be the length}
info(r):=0;
s:=get_avail; link(r):=s;  { first item pointer}
p:=get_avail; token_ref_count(p):=0; 
link(p):=get_avail;
memtraceup(4); 
info(link(p)):=end_match_token;
info(s):=p;  { first item}
@<Scan ahead to make sure there is real input, goto |found| otherwise@>;
{still alive, so ready to roll}
if list_sep=0 then begin {singleton lists initialize their own items}
   free_avail(link(p));
   free_avail(p);
   free_avail(s);
   memtracedown(3);
   link(r):=null;
   s:=r;
   info(r):=0;
end else p:=link(p);
seentok:=true; 
if list_sep<>0 then begin 
	l:=link(list_sep);
	info(r):=1;
end; 
loop@+ begin 
  if list_xpand then @<Expand the next part of the input@> else get_token;
  if cur_tok<right_brace_limit then
    if cur_cmd<right_brace then incr(unbalance)
    else begin 
      decr(unbalance);
      if unbalance=0 then goto found; {should be safe}
    end;  
  if list_sep<>0 then begin
    @<Build the body of the list; |goto found| when finished@>;
  end else begin
    @<Create a singleton list@>;
  end;
end


@ Nasty... if there is an empty group we don't want to create a 
list at all.  The |back_input| is only executed if the current token
was not the closing right brace, this is needed to make sure that we 
do not create fresh errors ourselves by `forgetting' to handle input 
tokens. 

@<Scan ahead to make sure there is real input, goto |found| otherwise@>=
get_token;
if cur_tok<right_brace_limit then
  if cur_cmd>=right_brace then begin 
	  {free the list business:}
      free_avail(link(p));
      free_avail(p);
      {free_avail(s);}
	  memtracedown(3); 
	  link(s):=null; {was link(r)}
	  info(r):=0;
      goto found; 
    end;
back_input

@ The trickery with |l| and the restart label makes sure we pass over
the item separators correctly. Note that because of the calls to |get_token|,
a list separator can not be partially part of a macro definition in the
case of \.{\\elistdef}, since it will never be expanded. Convenient.


We start here with |unbalance| equal to 1 (may get higher), |seentok| 
is true, and the current token is not the right brace that ends the list. 

@<Build the body of the list; |goto found| when finished@>=
if unbalance = 1 then 
if cur_tok = info(l) then 
 begin
  restart:
  if (link(l)<>null) then begin
  l:=link(l);
  get_token;
     if cur_tok = info(l) then goto restart
	 else begin 
       l:=link(list_sep); {restore |l| for next item} 
       back_input; {we read a token too much}
	 end;
  end 
  else l:=link(list_sep); {restore |l| for next item}
  {check whether we are done now:}
  get_token;
  start_an_item;
  incr(info(r));
  if cur_tok<right_brace_limit then
    if cur_cmd>=right_brace then begin {it's a right brace}
      if unbalance = 1 then  goto found; {trailing empty item}
      back_input;
    end else back_input {it's a left brace}
  else back_input; {not a brace at all}
 end
 else 					{|cur_tok| not part of |list_sep|}
  store_new_token(cur_tok)
else 					{|unbalance > 1|}
  store_new_token(cur_tok)


@ This doesn't count right (one too many), which is why the code above
had to reverse the item start code.

@<Create a singleton list@>=
  if unbalance = 1 then begin
    start_an_item;
	store_new_token(cur_tok);
    incr(info(r)); {this gives one too many} 
  end
  else
    store_new_token(cur_tok)


@ @<Cases for |eq_destroy|@>=
list_call: delete_list(equiv_field(w));


@ This is applist. Lots of local variables, but the important thing
to remember is that on exit, |def_ref| will point to a new list of 
items, even if there are no items at all. A list with size 0 is legal.
 

@p procedure app_list;
label restart,found,done,done2;
var l:pointer; {for item separator}
@!p:pointer; {tail of the item being built}
@!q:pointer; {new node being added to the token list via |store_new_token|}
@!a,@!b,@!r,@!s,@!v:pointer; {start and tail of the list being built}
@!unbalance:halfword; {number of unmatched left braces}
@!lengthl:halfword; {length of this list so far}
@!seentok:boolean; {seen a token?}
save_scanner_status:small_number; {temporary storage of |scanner_status|}
begin
save_scanner_status:=scanner_status; scanner_status:=defining; 
startmemtrace("appdef");
warning_index:=cur_cs; 
seentok:=false;
r:=null;
@<Check for legal input and get next token@>;
if cur_cmd = left_brace then begin
  @<Do the argument parsing that all list defs have in common@>;
end else begin 
  @<Insert list that already existed before@>;
end;
found: 
if not seentok then begin  {create dummy list with 0 items}
  if r=null then begin
    r:=get_avail;
    memtraceup(1);
    info(r):=0;
  end;
end;
if (eq_type(warning_index)<>list_call) then def_ref:=r
else begin 
    @<nasty trick to fool |define|@>;
    b:=a;
	lengthl:=info(a);
	while (lengthl>0) do begin
  		b:=link(b);
  		decr(lengthl);	
	end;
	info(a):= info(a) + info(r);
    link(b):= link(r);
    free_avail(r);
	memtracedown(1);
    def_ref:=a;
end;
scanner_status:=save_scanner_status;
stopmemtrace;
end;

@ This is prepend list.

@p procedure pre_list;
label restart,found,done,done2;
var l:pointer; {for item separator}
@!p:pointer; {tail of the item being built}
@!q:pointer; {new node being added to the token list via |store_new_token|}
@!a,@!b,@!r,@!s,@!v:pointer; {start and tail of the list being built}
@!unbalance:halfword; {number of unmatched left braces}
@!lengthl:halfword; {length of this list so far}
@!seentok:boolean; {seen a token?}
save_scanner_status:small_number; {temporary storage of |scanner_status|}
begin
save_scanner_status:=scanner_status; scanner_status:=defining; 
startmemtrace("predef");
warning_index:=cur_cs; 
seentok:=false;
@<Check for legal input and get next token@>;
if cur_cmd = left_brace then begin
  @<Do the argument parsing that all list defs have in common@>;
end else begin 
  @<Insert list that already existed before@>;
end;
found: 
if not seentok then begin  {create dummy list with 0 items}
  r:=get_avail;
  memtraceup(1);
  info(r):=0;
  link(r):=null;
  s:=r;
end;
if (eq_type(warning_index)<>list_call) then def_ref:=r
else begin 
	@<nasty trick to fool |define|@>;
	info(r):=info(a) + info(r); 
	link(s):=link(a);
    def_ref:=r;
end;
stopmemtrace;
scanner_status:=save_scanner_status;
end;


@ This is inslist. Lots of local variables, but the important thing
to remember is that on exit, |def_ref| will point to a new list of 
items, even if there are no items added at all.
@d  next_new_item==done4
@d  next_old_item==done5
@d  end_loop==done6

@p procedure uins_list;
label restart,found,done,done2,done3,done4,done5,done6;
var l:pointer; {for item pointer}
@!p:pointer; {tail of the item being built}
@!q:pointer; {new node being added to the token list via |store_new_token|}
@!a,@!b,@!r,@!s,@!v:pointer; {start and tail of the list being built}
@!unbalance:halfword; {number of unmatched left braces}
@!lengthl:halfword; {length of this list so far}
@!seentok:boolean; {seen a token?}
save_scanner_status:small_number; {temporary storage of |scanner_status|}
begin
save_scanner_status:=scanner_status; scanner_status:=defining; 
startmemtrace("insdef");
warning_index:=cur_cs; 
seentok:=false;
@<Check for legal input and get next token@>;
if cur_cmd = left_brace then begin
  @<Do the argument parsing that all list defs have in common@>;
end else begin 
  @<Insert list that already existed before@>;
end;
found: 
if not seentok then begin {no new additions}
  if eq_type(warning_index)=list_call then begin
  @<nasty trick to fool |define|@>;
  def_ref:=a;
  goto done3;
  end else begin 
  r:=get_avail;
  memtraceup(1);
  info(r):=0;
  link(r):=null;
  def_ref:=r;
  goto done3;
  end;
end;
if (eq_type(warning_index)<>list_call) or {not a list} 
   (info(equiv(warning_index))=0) then begin {empty list}
  def_ref:=r;
  goto done3;
end; {only additions}
begin
    seentok:=false;
    @<nasty trick to fool |define|@>;
    def_ref:=a; {|a| now holds the old list that we can play with}
   @<loop over the old list while we have new items@>;
end;
done3:
scanner_status:=save_scanner_status;
stopmemtrace;
end;

@ @<loop over the old list while we have new items@>=
lengthl:=info(r);
s:=r;
next_new_item:
while (lengthl>0) do begin
  s:=link(s);
  v:=info(s);
  b:=link(a);
  decr(lengthl);
  @<loop over old items comparing to |v|@>;
end

@ @<loop over old items comparing to |v|@>=
next_old_item:
while (link(b)<>null) do begin
  p:=info(b); 
  p:=link(p);
  q:=v; 
  q:=link(q);
  seentok:=false;
  while (info(p)=info(q)) do begin
    if (link(p)=null) and (link(q)<>null) then begin 
	    b:=link(b); goto next_old_item; end
    else if (link(q)=null) and (link(p)<>null) then begin 
	    b:=link(b); goto next_old_item; end
    else if (link(q)=null) and (link(p)=null) then begin 
		seentok:=true; 
        goto end_loop;
		end;
    p:=link(p);
    q:=link(q);
  end;
  b:=link(b);
end;
  p:=info(b); 
  p:=link(p);
  q:=v; 
  q:=link(q);
  seentok:=false;
  while (info(p)=info(q)) do begin
    if (link(p)=null) and (link(q)<>null) then goto next_old_item
    else if (link(q)=null) and (link(p)<>null) then goto next_old_item
    else if (link(q)=null) and (link(p)=null) then begin 
		seentok:=true; 
        goto end_loop;
		end;
    p:=link(p);
    q:=link(q);
  end;
end_loop: if seentok then goto next_new_item;
{if we reach this, the item did not exist: insert it}
incr(info(a));
p:=link(a);
q := get_avail;
memtraceup(1);
link(a):=q;
link(q):=p;
info(q):=v;
def_ref:=a


@ When we change a list using \.{\\appdef}, \.{\\predef}, \.{\\insdef}
or \.{\\delitem}, it is perfectly OK to kill off the old value of the
list. But unfortunately, there is a conflict with |define|: if the
current level stays the same, the old value will be destroyed without
saving the node lists. Therefore, we need to save the old value
ourselves.

@<nasty trick to fool |define|@>=
begin
b:=get_avail; 
memtraceup(1);
a:=equiv(warning_index);
info(b):=info(a);
p:=b;
while info(b) > 0 do begin
   decr(info(b));
   q:=get_avail;
   memtraceup(1);
   link(p):=q; 
   p:=link(p);
   a:=link(a);
   info(p):=info(a);
   incr(info(info(a))); {the ref count has to be updated as well}
end;
link(p):=null;
a:=equiv(warning_index); {fixes the counters}
info(b):=info(a);
equiv(warning_index):=b;
end


@ How to delete a list. 

@<Declare \eTeX\ procedures for tr...@>=
procedure delete_list(@!q:pointer); {gets ready to forget |q|}
var p:pointer;
@!l:halfword;
begin
p:=q;
l:=info(p);
if l = 0 then return;
startmemtrace("delete");
while l > 0 do begin
  p:=link(p);
  if info(p)<0 then begin 
	info(p):=0;
	print(" !!fixed a refcount!! ");
  end;
  if info(p)<>0 then delete_token_ref(info(p));
  decr(l);
end;
info(q):=0;
delete_token_ref(q); {force deletion of item list}
stopmemtrace;
end;


@ This is the way to write binary stuff to the dvi file.

@<Put each...@>=
primitive("packed",extension,packed_node);@/
@!@:packed_}{\.{\\packed} primitive@>

@ @<Implement \.{\\packed}@>=
begin new_whatsit(packed_node,write_node_size); write_stream(tail):=null;
p:=scan_toks(false,true); write_tokens(tail):=def_ref;
end

@ @<Declare procedures needed for packed output@>=
procedure dvi_three(@!x:integer);
begin if x>=0 then dvi_out(x div @'200000)
else  begin x:=x+@'200000;
  x:=x+@'200000;
  dvi_out((x div @'200000) + 128);
  end;
x:=x mod @'200000; dvi_out(x div @'400);
dvi_out(x mod @'400);
end;

@ @<Declare procedures needed for packed output@>=
procedure dvi_two(@!x:integer);
begin if x>=0 then dvi_out(x div @'400)
else  begin x:=x+@'400;
  x:=x+@'400;
  dvi_out((x div @'400) + 128);
  end;
dvi_out(x mod @'400);
end;

@ @<Declare procedures needed for packed output@>=
procedure packed_out(@!p:pointer);
var s:normal..absorbing; {to save |scanner_status|}
@!w:pointer; {to save |warning_index|}
begin s:=scanner_status; w:=warning_index; 
scanner_status:=absorbing; warning_index:=cur_cs;	
synch_h; synch_v;@/
begin_token_list(write_tokens(p),inserted);
while (loc<>null) do begin
	get_token;
	case cur_chr of
    " ": do_nothing;
	"a": begin
		 scan_eight_bit_int;
		 dvi_out(cur_val);
	     end;
	"b": begin
		 scan_int;
         if (cur_val<-65535)or(cur_val>65535) then
         begin print_err("Bad 16bit int");
         @.Bad 16bit int@>
         help2("A 16bit integer must be between -65535 and 65535.")@/
         ("I changed this one to zero."); int_error(cur_val); cur_val:=0;
         end;
		 dvi_two(cur_val);
	     end;
	"c": begin
		 scan_int;
         if (cur_val<-16777215)or(cur_val>16777215) then
         begin print_err("Bad 24bit int");
         @.Bad 24bit int@>
         help2("A 24bit integer must be between -16777215 and 16777215.")@/
         ("I changed this one to zero."); int_error(cur_val); cur_val:=0;
         end;
		 dvi_three(cur_val);
	     end;
	"d": begin
		 scan_int;
		 dvi_four(cur_val);
	     end;
	"f": begin
		 scan_normal_dimen;
		 dvi_four(cur_val);
		 end;
	othercases confusion("pack");
	endcases;
end;
end_token_list; {force deletion of item list}
while false do begin 
  delete_token_ref(write_tokens(p));
  pop_input;
  check_interrupt;
end;
scanner_status:=s; warning_index:=w; 
end;

@ In this branch we do not expand expanded characters. As a result,
|c| is available for use as closing delimiter.

@<Scan for a space or closer...@>=
begin
@<Set |c| to the closer@>;
repeat cur_chr:=buffer[k]; cat:=cat_code(cur_chr); incr(k);
until (cat=spacer)or(k>limit)or(cur_chr=c);
decr(k);
if k>loc+1 then {multiletter control sequence has been scanned}
  @<Gobble closer if there is one@>;
  begin cur_cs:=id_lookup(loc,k-loc); loc:=k; 
  goto found;
  end;
end

@ @<Set |c| to the closer@>=
if buffer[loc-1]="<" then c:=">"
else if buffer[loc-1]="(" then c:=")"
else if buffer[loc-1]="[" then c:="]"
else if buffer[loc-1]="&" then c:=";"
else c:=buffer[loc-1] 

@ @<Gobble closer if there is one@>=
if (buffer[k]=c) then begin 
	if (c=";") then begin incr(k); end
		else state:=mid_line;
end 
  
@ Time to worry about some \.{\\if} tests. There are three different
tests possible at the moment: \.{\\ifhasitem} returns true if one of
the items exists, \.{\\ifsublist} returns true if all of the items
exist and are in the correct order as well, and \.{\\ifsubset} returns
true if the listed items appear anywhere in the list.

@d if_has_item_code=20 { `\.{\\ifhasitem}' }
@d if_has_items_code=21 { `\.{\\ifsublist}' }
@d if_subset_code=22 { `\.{\\ifsubset}' }
@d if_subitem_code=23 { `\.{\\ifsubitem}' }
@d if_list_code=24 { `\.{\\iflist}' }

@<Generate all \eTeX...@>=
primitive("ifhasitem",if_test,if_has_item_code);
@!@:if_has_item_}{\.{\\ifhasitem} primitive@>
primitive("ifsublist",if_test,if_has_items_code);
@!@:if_has_items_}{\.{\\ifsublist} primitive@>
primitive("ifsubset",if_test,if_subset_code);
@!@:if_subset_}{\.{\\ifsubset} primitive@>
primitive("ifsubitem",if_test,if_subitem_code);
@!@:if_subitem_}{\.{\\ifsubitem} primitive@>
primitive("iflist",if_test,if_list_code);
@!@:if_list_}{\.{\\iflist} primitive@>
 
@ @<Cases of |if_test| for |print_cmd_chr|@>=
if_has_item_code:print_esc("ifhasitem");
if_has_items_code:print_esc("ifsublist");
if_subset_code:print_esc("ifsubset");
if_subitem_code:print_esc("ifsubitem");
if_list_code:print_esc("iflist");

@ @<Glob...@>=
listitemcheck:halfword; {what kind of verification for list checks}
listitemordinal:integer; {ordinal number of the found item}

@ @<Set init...@>=
listitemcheck:=0;
listitemordinal:=0;

@ @<Declare \eTeX\ procedures for sc...@>=
procedure@?verifylist; forward;@t\2@>


@ This function does all the work. if |allitems| is true, than 
all items will be checked. otherwise, the first succesful match
returns |true|. Of course I tried this with a |function| first,
but that didn't work because of crossing forward declarations...sigh. 

If |ordered| is true, it is required that the list items appear
in the given order: the list will not be re-wound before trying 
the next item that should be verified.
@d make_a_macro(#)== #:=get_avail;
	link(#):=get_avail;
    memtraceup(2);
	info(#):=0;
	info(link(#)):=end_match_token;

@p procedure verifylist;
label restart,found,done,done2,done3,done4,done5,done6;
var l:pointer; {for item pointer}
@!p:pointer; {tail of the item being built}
@!q:pointer; {new node being added to the token list via |store_new_token|}
@!a,@!b,@!r,@!s,@!v:pointer; {start and tail of the list being built}
@!unbalance:halfword; {number of unmatched left braces}
@!lengthl:halfword; {length of this list so far}
@!seentok:boolean; {seen a token?}
@!result:halfword; {the result counter}
@!request:halfword; {the desired number}
@!ordered:boolean;
@!subitem:boolean;
@!mycs:halfword;
save_scanner_status:small_number; {temporary storage of |scanner_status|}
begin
save_scanner_status:=scanner_status; 
startmemtrace("verify");
scanner_status:=normal; 
warning_index:=cur_cs; 
get_token;
mycs := cur_cs;
seentok:=false;
listitemordinal:=0;
@<Check for legal input and get next token@>;
if cur_cmd = left_brace then begin
  @<Do the argument parsing that all list defs have in common@>;
end else begin 
  @<Insert list that already existed before@>;
end;
found: 
result := 0; request := 1; {init}
if (info(r)=0) or (seentok=false) then begin 
  result := request; {no new items to test}
  free_avail(r);
  memtracedown(1);
  goto done3;  
end;
if (eq_type(mycs)<>list_call) or 
   (info(equiv(mycs))=0) then begin 
  result := 0; {not a list, or an empty one} 
  goto done3;
end; 
if listitemcheck>0 then request := info(r) else request := 1;
if listitemcheck=2 then ordered := true else ordered := false;
if listitemcheck=3 then begin 
	subitem := true;
	request := 1;
end else subitem := false;
begin
    seentok:=false;
    a := equiv(mycs);
    @<verify the old list while we have new items@>;
end;
done3:
scanner_status:=save_scanner_status;
if result<request then begin 
	listitemordinal:=0;
	{clear lastitemdata} 
	make_a_macro(p);
	geq_define(lastitem_contents_loc,long_call,p);
	listitemcheck:=0;
end else begin 
	if (listitemordinal=0) then begin 
		{clear lastitemdata} 
		make_a_macro(p);
		geq_define(lastitem_contents_loc,long_call,p);
		listitemcheck:=1;
	end else begin
		if subitem then begin
			make_a_macro(q);
			if link(p)<>null then
				@<Make a copy of the remaining item@>;
			geq_define(lastitem_contents_loc,long_call,q);
		end else begin
			incr(info(v)); {ref count}
			geq_define(lastitem_contents_loc,long_call,v);
		end;
		listitemcheck:=1;
	end;
end;
if r<>null then delete_list(r);
stopmemtrace;
end;

@ This module might have to remove braces too. If the remaining part
of this item is completely enclosed by one group of braces, that group
will be removed. We have to be a little bit careful, because the
remainder might actually consist of two separate braced groups. We can
re-use the |unbalance| counter for keeping track of the braces
themselves, and (mis)use the boolean |subitem| to decide whether or
not a final brace should be removed.

Most items will not start with a brace at all, so it seems best to
optimize for this case. Only explicit braces count!  After the copying
is done, braces can be removed if the following conditions are met:
|info(link(link(q)))| is a left brace (this is always true), |info(b)|
is a right brace, and |subitem| is still true. The smallest possible
item is then just a brace group.

@<Make a copy of the remaining item@>=
begin
b:=get_avail;
  memtraceup(1);
link(link(q)):=b;
p:=link(p);
if info(p)=left_brace_token+"{" then
begin
  unbalance:=1;
  subitem:=true;
  info(b):=info(p);
  while link(p) <> null do begin
    link(b):=get_avail;
    memtraceup(1);
    b:=link(b);
    p:=link(p);
    info(b):=info(p);
    if info(b)=left_brace_token+"{" then incr(unbalance)
	else if info(b)=right_brace_token+"}" then begin
		decr(unbalance);
		if unbalance=0 then if (link(p)<>null) then subitem:=false;
	end;
  end;
  if (info(b)=right_brace_token+"}") and (subitem) then begin
		b:=link(link(q));
		link(link(q)):=link(b);
		free_avail(b); {one down ...}
		b:=link(link(q));
		if link(b)=null then begin 
          free_avail(link(link(q))); {single braces case ...}
   		  link(link(q)):=null; 
		end else begin
          while (link(link(b))<>null) do b:=link(b);
		  free_avail(link(b)); {second one}
	      link(b):=null;
		end;
		memtracedown(2);
  end;
end else begin
  info(b):=info(p);
  while link(p) <> null do begin
    link(b):=get_avail;
    memtraceup(1);
    b:=link(b);
    p:=link(p);
    info(b):=info(p);
  end;
end;
end



@ Short recap: |r| is the start of the items to be compared.  |a| is
the start of the old list. |lengthl| length of the new list of items to 
be compared. |s| moves through the new items, |b| moves through the 
old list.  
@d stepitemb == if link(b)<>null then b:=link(b) else goto done3

@<verify the old list while we have new items@>=
lengthl:=info(r);
s:=r;
b:=a; 
next_new_item:
listitemordinal:=0;
while (lengthl>0) do begin
  decr(lengthl);
  s:=link(s);
  v:=info(s);
  if (v = 0) or (link(v)=null) then goto next_new_item;
  if not ordered then b:=link(a) 
  else stepitemb;
  @<verify old items comparing to |v|@>;
end

@ This |while| loop is a bit sad. 

@<verify old items comparing to |v|@>=
@<check one item@>;
next_old_item:
while (link(b)<>null) do begin
  b:=link(b);
  @<check one item@>;
end;
@<check one item@>;
end_loop: 
if result<request then goto next_new_item else goto done3


@ @<check one item@>=
p:=info(b); 
if p=0 then goto next_old_item;
if link(p)<>null then p:=link(p) {skip over ref count}
	else begin if link(b)=null then goto end_loop else 
	goto next_old_item end;
if (link(p)=null) and (info(p)=end_match_token) then {guard against empty macros}
	begin if link(b)=null then goto end_loop else 
	goto next_old_item end;
q:=v; 
q:=link(q);
incr(listitemordinal);
while (info(p)=info(q)) do begin
    if (link(p)=null) and (link(q)<>null) then begin if link(b)=null then 
				goto end_loop else goto next_old_item end
    else if (link(q)=null) and (link(p)<>null) then begin
         if subitem then begin
           incr(result);
           goto end_loop;
         end else begin if link(b)=null then goto end_loop else 
				goto next_old_item end;
        end
    else if (link(q)=null) and (link(p)=null) then begin 
		incr(result);
        goto end_loop;
        end;
    p:=link(p);
    q:=link(q);
end


@ Sorry for the global variable here. I know this is not pretty, but
it seems to the only way to go without re-writing the whole source
code.

@d checkitems(#)==begin listitemcheck:=#; verifylist; if listitemcheck > 0
               then b:=true else b:=false; end

@<Cases for |conditional|@>=
if_has_item_code:  checkitems(0);
if_has_items_code: checkitems(2);
if_subset_code:    checkitems(1);
if_subitem_code:   checkitems(3);
if_list_code:      begin 
					 get_r_token; 
				   	 if eq_type(cur_cs)=list_call then b:=true 
					 else b:=false; 
                   end;

@ Item manipulation primitives. 

@<Generate all \eTeX...@>=
primitive("getitem",read_to_cs,2);@/
@!@:get_item_}{\.{\\getitem} primitive@>
primitive("setitem",read_to_cs,3);@/
@!@:set_item_}{\.{\\setitem} primitive@>
primitive("delitem",read_to_cs,4);@/
@!@:del_item_}{\.{\\delitem} primitive@>
primitive("insitem",read_to_cs,5);@/
@!@:ins_item_}{\.{\\insitem} primitive@>

@ @<Cases of |read_to_cs| for eetex@>=
if chr_code = 2 then print_esc("getitem") else
if chr_code = 3 then print_esc("setitem") else
if chr_code = 4 then print_esc("delitem") else
if chr_code = 5 then print_esc("insitem") 

@ |a|=prefix, |b,p,q,v| are pointers, |j|=halfword, |n| = integer.
|q| points to our list, |n| to the needed item.

@<Handle |read_to_cs| for eetex@>=
begin 
if cur_chr = 2 then begin @<Do |getitem|@>; end
else if cur_chr = 3 then begin @<Do |setitem|@>; end
else if cur_chr = 4 then begin @<Do |delitem|@>; end
else if cur_chr = 5 then begin @<Do |insitem|@>; end;
end

@ @< Do |getitem|@> =
startmemtrace("getitem");
@<parse all tokens@>;
q:=equiv(r);
@<Fix the item counters@>;
if not boundserr then begin
  while (n>0) do begin
   decr(n);
   q:=link(q);
  end;
  q:=info(q); {the item}
  if (q<>0) and (link(q)<>null) then begin 
	incr(info(q)); {it's refcount}
    define(p,call,q);
    end else begin
	  if q=0 then begin q:=get_avail; 
	    memtraceup(1);
		end;
      if link(q)=null then begin 
		link(q):=get_avail;
	    memtraceup(1);
	  end;
	  info(q):=0;
	  info(link(q)):=end_match_token;
	  link(link(q)):=null;
      define(p,call,q);
	end;
end;
stopmemtrace

@ @< Do |setitem|@> =
startmemtrace("setitem");
@<parse all tokens@>;
if not boundserr then begin
 if (eq_type(cur_cs)<call) then begin 
        if tracing_lists>0 then begin
		  print_nl("{"); print_esc("setitem");		
		  print(" command code is ");		
		  print_int(cur_cmd);
		  print(" token is ");		
		  print_int(cur_chr);
		  print("}");
		end;
   if (eq_type(cur_cs)<max_char_code) then begin
		{create a `macro' that is valid in this context}
		p:=get_avail;
		link(p):=get_avail;
		info(p):=0; {ref count}
		info(link(p)):=end_match_token;
	    link(link(p)):=get_avail;
	    memtraceup(3);
	    info(link(link(p))):=(cur_cmd*256)+cur_chr;
	    link(link(link(p))):=null;
   end else boundserr:=true;
 end else begin
  p:=equiv(p);
  incr(info(p)); {it's refcount}
 end;
 @<make a copy of the list@>;
 q:=v;
end;
@<Fix the item counters@>;
if not boundserr then begin
while (n>0) do begin
   decr(n);
   q:=link(q);
  end; 
if info(q)<>0 then delete_token_ref(info(q)); {the old item}
  info(q):=p; {insert item. !!this is always global!!}
  define(r,list_call,v);
end;
stopmemtrace


@ @< Do |insitem|@> =
startmemtrace("insitem");
@<parse all tokens@>;
if not boundserr then begin
 if (eq_type(cur_cs)<call) then begin 
        if tracing_lists>0 then begin
		  print_nl("{"); print_esc("insitem");		
		  print(" command code is ");		
		  print_int(cur_cmd);
		  print(" token is ");		
		  print_int(cur_chr);
		  print("}");
		end;
   if (eq_type(cur_cs)<max_char_code) then begin
		{create a `macro' that is valid in this context}
		p:=get_avail;
		link(p):=get_avail;
		info(p):=0; {ref count}
		info(link(p)):=end_match_token;
	    link(link(p)):=get_avail;
	    memtraceup(3);
	    info(link(link(p))):=(cur_cmd*256)+cur_chr;
	    link(link(link(p))):=null;
   end else boundserr:=true;
 end else begin
  p:=equiv(p);
  incr(info(p)); {it's refcount}
 end;
 @<make a copy of the list@>;
 q:=v;
end;
@<Fix the item counters@>;
if not boundserr then begin
while (n>0) do begin
   decr(n);
   q:=link(q);
  end;  
s:=get_avail;
  memtraceup(1);
link(s):=link(q);
link(q):=s;
info(s):=info(q); {insert item}
info(q):=p;
incr(info(v));
define(r,list_call,v);
end;
stopmemtrace

@ @< Do |delitem|@> =
startmemtrace("delitem");
@<parse all tokens@>;
if not boundserr then begin 
 @<make a copy of the list@>;
 q:=v;
 @<Fix the item counters@>;
end;
if not boundserr then begin
 s:=q; { used for deletion}
 while (n>0) do begin
   decr(n);
   s:=q;
   q:=link(q);
  end;
  link(s):=link(q);
  s:=info(q); {the item}
  free_avail(q);
  memtracedown(1);
  if (s<>0) and (link(s)<>null) then begin 
	define(p,call,s);
  end else begin
	  if s=0 then begin 
		s:=get_avail;
	    memtraceup(1);
	  end;	
      if link(s)=null then begin 
		  link(s):=get_avail;
		  memtraceup(1);
	  end;
	  info(s):=0;
	  info(link(s)):=end_match_token;
	  link(link(s)):=null;
      define(p,call,s);
  end;
  decr(info(v));
  define(r,list_call,v);
end;
stopmemtrace
   
@ Uses |j| and |n| for calculation, and |r| to find
the csname.

@<Fix the item counters@>=
if not boundserr then begin
j:=info(equiv(r)); {lenght}
if n < 0 then n := j - abs(n) +1;
if (n>j) or (n=0) then begin
       boundserr:=true;
       if tracing_lists>0 then begin 
       print_nl("{out of bounds absolute item number ");
	   print_int(n); print("; max is "); print_int(j); 
		print("; ifnoring this command}");
       end;
end;
end

@ Changes s,q,v and b. Uses r. On exit, |v| will be the freed list.

@<make a copy of the list@>=
begin
s:=p; {save pointer}
b:=get_avail;
memtraceup(1);
v:=equiv(r);
info(b):=info(v);
p:=b;
while info(b) > 0 do begin
   decr(info(b));
   q:=get_avail;
  memtraceup(1);
   link(p):=q; 
   p:=link(p);
   v:=link(v);
   info(p):=info(v);
   incr(info(info(v))); {the ref count has to be updated as well}
end;
link(p):=null;
v:=equiv(r); {fixes the counters}
info(b):=info(v);
equiv(r):=b;
p:=s;
end

@ This leaves us with |r| pointing to the list, |n| the specified number, and 
|p| pointing to the csname. |boundserr| will be true if there was a fatal
parse error.

@<parse all tokens@>=
boundserr:=false;
if tracing_lists>1 then begin
	print_nl("{");
	print_cmd_chr(cur_cmd,cur_chr);
	print(": ");
end;
get_token;
if (eq_type(cur_cs)<>list_call) or 
    (info(equiv(cur_cs))=0) then begin 
    print_err("Missing listname");
@.Missing `csname'...@>
    help2("You should have said `\...item\list<number> to \cs'.")@/
    ("I'm going to ignore this whole command."); error;
     scan_int; 
	 boundserr := scan_keyword("to");
     get_r_token;
     boundserr:=true;
     end 
else begin
  r:=cur_cs;
  scan_int;
  n := cur_val;
if tracing_lists>1 then begin
	print("specified item "); print_int(n);
	print(" from "); sprint_cs(r);
end;
  if not scan_keyword("to") then
    begin print_err("Missing `to' inserted");
@.Missing `to'...@>
    help2("You should have said `\...item\list<number> to \cs'.")@/
    ("I'm going to look for the \cs now."); error;
    end;
  get_r_token;
  p:=cur_cs;
  if tracing_lists>1 then begin
	print(" and csname "); sprint_cs(p);
	print("}");
end;
end

@ @<Generate all \eTeX...@>=
primitive("itemnumber",last_item,item_call_code);
@!@:item_call_}{\.{\\itemnumber} primitive@>
primitive("subitemnumber",last_item,subitem_call_code);
@!@:subitem_call_}{\.{\\subitemnumber} primitive@>

@ @<Cases of |last_item| for |print_cmd_chr|@>=
item_call_code: print_esc("itemnumber");
subitem_call_code: print_esc("subitemnumber");


@ @<Cases for fetching an integer value@>=
item_call_code: begin
listitemcheck:=0;
verifylist;
cur_val:=listitemordinal;
end;
subitem_call_code: begin
listitemcheck:=3;
verifylist;
cur_val:=listitemordinal;
end;



@ This is resizelist.

@p procedure resize_list;
label restart,found,done,done2;
var l:pointer; {for item separator}
p,q:pointer; {items being built through |store_new_token|}
r,s:pointer; {start and tail of the list being built}
v:pointer; {to save |s| in the |define| trick}
a,b:pointer; {spare pointers?}
@!lengthl,@!n,@!m:halfword; {lengths of this list so far}
begin
r:=cur_cs; 
startmemtrace("newlist");
if eq_type(r)<>list_call then begin 
  v:=get_avail;
  memtraceup(1);
  info(v):=0;
  link(v):=null;
end else
@<make a copy of the list@>; {new list in |v|}
scan_int;
lengthl:=cur_val;
if lengthl < 0 then lengthl := abs(lengthl);
if n=lengthl then goto done2;
n:=info(v);
m:=lengthl;
if n>m then begin {delete items}
  info(v):=m;
  p:=link(v);
  while (m>0) do begin
	decr(m); 
    p:=link(p);   
	end;
  link(p):=null;
end
else begin
  info(v):=m;
  p:=v;
  while (n>0) do begin
	p:=link(p);   
	decr(m); 
    decr(n); 
    end;
  while(m>0) do begin
    decr(m);
    link(p):=get_avail;
    p:=link(p);
    info(p):=get_avail;
    info(info(p)):=0;
    link(info(p)):=get_avail;
    memtraceup(3);
	info(link(info(p))):=end_match_token;
	link(link(info(p))):=null;
    end;
  link(p):=null;
end;
done2:
def_ref:=v;
stopmemtrace
end;

@ This is part of the \.{\\scanlist} primitive.

@p procedure scan_list;
var a,@!b,@!r,@!s,@!p,@!q:pointer; 
@!lengthl:halfword; {length}
begin
startmemtrace("scanlist");
  while (state=token_list)and(loc=null) do end_token_list;
  r:=equiv(cur_cs);
  if eq_type(cur_cs)=list_call then  
  	lengthl:=info(r) else lengthl:=0;
  get_token;
  if eq_type(cur_cs)>list_call then  
		do_nothing else lengthl:=0;
  {verify that |cur_cs| is a macro}  
  if lengthl <> 0 then begin
	a:=get_avail;
    memtraceup(1);
	s:=a;
	while lengthl > 0 do begin
      r:=link(r);
      decr(lengthl);
      if info(r)<>0 then begin
         {insert command} 
         p:=info(r);
         info(a):=cur_tok;
         link(a):=get_avail;
         q:=a; a:=link(a);
         {insert begingroup}
         info(a):="{"+left_brace_token;
         link(a):=get_avail;
         q:=a; a:=link(a);
         @<insert an item argument in the input@>;
         info(a):="}"+right_brace_token;
         link(a):=get_avail;
         q:=a; a:=link(a);
         memtraceup(3);
       end;
    end;
  a:=q;
  free_avail(link(a));
  memtracedown(1);
  link(a):=null;
  end else begin {zero items}
     s:=get_avail;
     memtraceup(1);
     info(s):=cs_token_flag+frozen_relax;
	 link(s):=null; 
  end;
  begin_token_list(s,list_scan);
stopmemtrace;
end;

@ @<insert an item argument in the input@>=
while (info(p)<>end_match_token) and (link(p)<>null) do begin
p:=link(p);
end;
while link(p)<>null do begin
     p:=link(p);
     info(a):=info(p);
     link(a):=get_avail;
     memtraceup(1);
     q:=a; a:=link(a);
end



@ Scanning a list
@d scan_list_code = 3

@<Generate all \eTeX...@>=
primitive("scanlist",input,scan_list_code);
@!@:scan_list_}{\.{\\scanlist} primitive@>

@ @<Cases of |input| for |print_cmd_chr|@>=
else if chr_code=scan_list_code then print_esc("scanlist")

@ @<Cases for |input|@>=
else if cur_chr=scan_list_code then begin
  get_r_token;
  scan_list;
end

@ This code belongs to \.{\\ifx}. Whereas the implementation of the
test is fairly simple, watch out for the fact that the integers |m|
and |n| are used as pointers (for memory management). 

@<Test if two list texts match@>=
begin
if info(equiv(n))<>info(equiv(cur_cs)) then b:=false 
else 
  begin
    startmemtrace("list ifx");
    q:=the_list; m:=q;
    cur_cs:=n; {for |the_list|}
    p:=the_list; n:=p;
    if (p=null) or (q=null) then begin
		if p=q then b:=true else begin
			b:=false;
            if p=null then flush_list(q) else flush_list(p);
        end;
    end else begin
      b:=true;
      while (link(p)<>null) and link(q)<>null do begin
        p:=link(p); 
	    q:=link(q);
        if info(p)<>info(q) then b:=false;
      end;
      if (link(p)=null) and (link(q)=null) and (b=true) then
		do_nothing else b:=false; 
      flush_list(m);
      flush_list(n);
    end;
  end;
  startmemtrace("thelist");
end

@ 
@p procedure app_toks;
label done;
var p,q,r,s,t,u:pointer;
e:boolean;
a:integer;
b:pointer;
begin
a:=listitemcheck;
q:=cur_cs;
e:=false; {just in case, will be set |true| for sparse array elements}
@<Fetch the left-hand side as a token parameter@>;

@<Get the next non-blank non-relax non-call token@>;
if cur_cmd<>left_brace then begin
	@<Fetch the right-hand side as a token parameter@>;
    @<Make a copy of the right-hand side@>;
end else begin 
	back_input; 
    cur_cs:=q; 
    q:=scan_toks(false,false);
	q:=def_ref;
    if link(q)=null then goto done;
    @<Make a copy of the right-hand side@>;
end; {now |q|, |u| hopefully points to the new stuff}
begin
      if p<>null then link(t):=link(q) else p:=q; {delete refcount}
      if (b=output_routine_loc)and not e then {enclose in curlies}
        begin 
        link(u):=get_avail; u:=link(u);
        info(u):=right_brace_token+"}";
        q:=get_avail; 
        info(q):=left_brace_token+"{";
        link(q):=link(p); 
        link(p):=q;
	    memtraceup(2);
      end;
      sa_define(b,p)(b,call,p);
end;
done:
end;


@
@p procedure pre_toks;
label done;
var p,q,r,s,t,u:pointer;
e:boolean; 
a:integer;
b:pointer; {for csname}

begin
a:=listitemcheck;
q:=cur_cs;
e:=false; {just in case, will be set |true| for sparse array elements}
@<Fetch the left-hand side as a token parameter@>;
{now |p| hopefully points to the old stuff}
@<Get the next non-blank non-relax non-call token@>;
if cur_cmd<>left_brace then begin
	@<Fetch the right-hand side as a token parameter@>;
    @<Make a copy of the right-hand side@>;
end else begin 
	back_input; 
    cur_cs:=q; 
    q:=scan_toks(false,false);
	q:=def_ref;
    if link(q)=null then goto done;
    @<Make a copy of the right-hand side@>;
end;  {now |q|, |u| hopefully points to the new stuff}
begin 
      if p<>null then link(u):=link(p) else t:=u; {delete refcount}
      p:=q; 
      if (b=output_routine_loc)and not e then {enclose in curlies}
      begin link(t):=get_avail; t:=link(t);
      info(t):=right_brace_token+"}";
      q:=get_avail; info(q):=left_brace_token+"{";
      link(q):=link(p); link(p):=q;
      memtraceup(2);
      end;
    sa_define(b,p)(b,call,p);
end;
done:
end;

@ We will set |b| to the csname that has to be defined, 
|p| to the start of the token list that represents the 
current meaning, and |t| to it's end.

@<Fetch the left-hand side as a token parameter@>=
get_r_token;
if cur_cmd=toks_register then begin
    if cur_chr=mem_bot then
      begin scan_register_num;
      if cur_val>255 then
        begin find_sa_element(tok_val,cur_val,true);
        cur_chr:=cur_ptr; e:=true;
        end
      else cur_chr:=toks_base+cur_val;
      end
    else e:=true;
  b:=cur_chr; {|p=every_par_loc| or |output_routine_loc| or \dots}
  p:=equiv(cur_chr);
  @<Make a copy of the left-hand side@>;
end else if cur_cmd=assign_toks then begin 
    b:=cur_chr;
    p:=equiv(cur_chr);
  @<Make a copy of the left-hand side@>;
  if (b=output_routine_loc)and not e and p<>null then 
       begin
       t:=r; {the almost-last one}
       free_avail(s);
       link(t):=null;
       s:=link(p);
       link(p):=link(s);
       free_avail(s); {the one after the refcount}
       memtracedown(2);
end;
end else goto done

@ @<Make a copy of the left-hand side@>=
if p=null then begin 
   do_nothing;
end else begin
  s:=get_avail;
  memtraceup(1);
  t:=s;
  info(s):=info(p);
  while (link(p)<>null) do begin
    link(s):=get_avail;
    memtraceup(1);
    r:=s;
    s:=link(s);
    p:=link(p);
    info(s):=info(p);
  end;
  p:=t;
  t:=s
end



@ @<Fetch the right-hand side as a token parameter@>=
if (cur_cmd=toks_register)or(cur_cmd=assign_toks) then
  begin if cur_cmd=toks_register then
    if cur_chr=mem_bot then
      begin scan_register_num;
      if cur_val<256 then q:=equiv(toks_base+cur_val)
      else  begin find_sa_element(tok_val,cur_val,false);
        if cur_ptr=null then q:=null
        else q:=sa_ptr(cur_ptr);
        end;
      end
    else q:=sa_ptr(cur_ptr)
  else q:=equiv(cur_chr);
  if q=null then goto done;
  end else goto done

@ @<Make a copy of the right-hand side@>=
    s:=get_avail;
    memtraceup(1);
    u:=s;
    info(s):=info(q);
    while (link(q)<>null) do begin
      link(s):=get_avail;
      memtraceup(1);
      s:=link(s);
      q:=link(q);
      info(s):=info(q);
    end;
    q:=u;
    u:=s

@ @<Kill off a list@>=
quit_list

@ 
@p procedure quit_list;
var n:integer;
begin
if (cur_val<1) and (state=token_list) then loc:=null
else if (cur_val<input_ptr) then begin
    n:=input_ptr;
    while (n>=0) do begin
     if (input_stack[n].state_field=token_list) and 
		(input_stack[n].index_field=list_scan) then
        begin
           decr(cur_val);
           if (cur_val=0) then begin
		     input_stack[n].loc_field:=null;
			 if tracing_lists>0 then begin
				print_nl("{quitlist: quitting list on input level ");
			    print_int(n);
                print("}");
			 end;
             n:=0;
           end;
        end;
     decr(n);
     end;
end;
end;


@ @<Generate all \eTeX...@>=
primitive("tracinglists",assign_int,int_base+tracing_lists_code);@/
@!@:tracing_lists_}{\.{\\tracinglists} primitive@>

@ @<Cases for |print_param|@>=
tracing_lists_code:print_esc("tracinglists");

@ @<Make the first 256 strings@>=
;
list_sep:=mem_top-15;
info(list_sep):=0;
link(list_sep):=mem_top-16;
info(link(list_sep)):=other_token+",";
link(link(list_sep)):=null;


@ @<Glob...@>=
lastitem_contents_loc:integer;

@ \.{\\lastitemdata} is not really a primitive, it's a csname. 
Initialization is a little tricky.

@<Generate all \eTeX...@>=
primitive("lastitemnumber",last_item,lastitem_number_code);
@!@:lastitem_number_}{\.{\\lastitemnumber} primitive@>
primitive("lastitemdata",last_item,lastitem_data_code);
@!@:lastitem_data_}{\.{\\lastitemdata} primitive@>
lastitem_contents_loc:=cur_val;

@ @<Cases of |last_item| for |print_cmd_chr|@>=
lastitem_number_code: print_esc("lastitemnumber");
lastitem_data_code: print_esc("lastitemdata");

@ @<Cases for fetching an integer value@>=
lastitem_number_code: cur_val:=listitemordinal;
lastitem_data_code: do_nothing;

@ @<Dump the \eTeX\ state@>=
dump_int(lastitem_contents_loc);@/

@ @<Undump the \eTeX\ state@>=
undump_int(lastitem_contents_loc);

@* \[54] System-dependent changes.
@z
